#include "../module/1284p/GpioRead.h"
#include "../module/1284p/GpioWrite.h"
#include "../module/1284p/AnalogRead.h"
#include "../module/1284p/SoundWrite.h"
#include "../module/1284p/Timer.h"
#include "../module/1284p/Delay.h"
#include "../module/1284p/Math.h"
#include "../module/1284p/Filter.h"
#include "../module/1284p/Hysteresis.h"
#include "../module/1284p/Max7219.h"
#include "../module/1284p/Nrf24l01p.h"
#include "../module/1284p/Tool.h"

int main()
{
	unsigned char n = 0;
	GpioRead switchPowerState = GpioRead (1, false, 10);//à remettre à la finalisation
	GpioWrite switchPowerHold = GpioWrite (2);
	Max7219 display = Max7219 (3, 1);
	GpioRead buttonSelect = GpioRead (9, true, 100);
	GpioRead switchCut = GpioRead (10, true, 10);
	GpioRead switchAuxiliaryA1 = GpioRead (11, true, 10);
	GpioRead switchAuxiliaryA2 = GpioRead (12, true, 10);
	GpioRead switchAuxiliaryB1 = GpioRead (13, true, 10);
	GpioRead switchAuxiliaryB2 = GpioRead (14, true, 10);
	GpioRead switchAuxiliaryC1 = GpioRead (15, true, 10);
	GpioRead switchAuxiliaryC2 = GpioRead (16, true, 10);
	GpioRead switchTrimThrottle1 = GpioRead (17, true, 10);
	GpioRead switchTrimThrottle2 = GpioRead (18, true, 10);
	GpioRead switchTrimPitch1 = GpioRead (19, true, 10);
	GpioRead switchTrimPitch2 = GpioRead (20, true, 10);
	GpioRead switchTrimRoll1 = GpioRead (21, true, 10);
	GpioRead switchTrimRoll2 = GpioRead (22, true, 10);
	GpioRead switchTrimYaw1 = GpioRead (23, true, 10);
	GpioRead switchTrimYaw2 = GpioRead (24, true, 10);
	AnalogRead potentiometerSelect = AnalogRead (25);
	AnalogRead potentiometerThrottle = AnalogRead (26);
	AnalogRead potentiometerPitch = AnalogRead (27);
	AnalogRead potentiometerRoll = AnalogRead (28);
	AnalogRead potentiometerYaw = AnalogRead (29);
	AnalogRead potentiometerAuxiliaryD = AnalogRead (30);
	AnalogRead voltageBatteryControl = AnalogRead (31);
	Nrf24l01p channelThrottleRollAuxiliaryCAuxiliaryD = Nrf24l01p (1);
	Nrf24l01p channelPitchYawCutAuxiliaryAAuxiliaryBFailSafeUpdate = Nrf24l01p (2);
	Nrf24l01p channelTelemetry = Nrf24l01p (3);
	Nrf24l01p channelSettingBatteryTimer = Nrf24l01p (4);
	Nrf24l01p channelSettingTrim = Nrf24l01p (5);
	Nrf24l01p channelSettingOptionWord1 = Nrf24l01p (6);
	Nrf24l01p channelSettingOption1 = Nrf24l01p (7);
	Nrf24l01p channelSettingOptionWord2 = Nrf24l01p (8);
	Nrf24l01p channelSettingOption2 = Nrf24l01p (9);
	Nrf24l01p channelSettingOptionWord3 = Nrf24l01p (10);
	Nrf24l01p channelSettingOption3 = Nrf24l01p (11);
	Nrf24l01p channelSettingOptionWord4 = Nrf24l01p (12);
	Nrf24l01p channelSettingOption4 = Nrf24l01p (13);
	Nrf24l01p channelSettingOptionWord5 = Nrf24l01p (14);
	Nrf24l01p channelSettingOption5 = Nrf24l01p (15);
	Nrf24l01p channelSettingOptionWord6 = Nrf24l01p (16);
	Nrf24l01p channelSettingOption6 = Nrf24l01p (17);
	Nrf24l01p channelSettingOptionWord7 = Nrf24l01p (18);
	Nrf24l01p channelSettingOption7 = Nrf24l01p (19);
	Nrf24l01p channelSettingOptionWord8 = Nrf24l01p (20);
	Nrf24l01p channelSettingOption8 = Nrf24l01p (21);
	Nrf24l01p channelSettingOptionWord9 = Nrf24l01p (22);
	Nrf24l01p channelSettingOption9 = Nrf24l01p (23);
	Nrf24l01p channelSettingOptionWord10 = Nrf24l01p (24);
	Nrf24l01p channelSettingOption10 = Nrf24l01p (25);
	Nrf24l01p channelSettingOptionWord11 = Nrf24l01p (26);
	Nrf24l01p channelSettingOption11 = Nrf24l01p (27);
	Nrf24l01p channelSettingOptionWord12 = Nrf24l01p (28);
	Nrf24l01p channelSettingOption12 = Nrf24l01p (29);
	Nrf24l01p channelSettingOptionWord13 = Nrf24l01p (30);
	Nrf24l01p channelSettingOption13 = Nrf24l01p (31);
	Nrf24l01p channelSettingOptionWord14 = Nrf24l01p (32);
	Nrf24l01p channelSettingOption14 = Nrf24l01p (33);
	Nrf24l01p channelSettingOptionWord15 = Nrf24l01p (34);
	Nrf24l01p channelSettingOption15 = Nrf24l01p (35);
	Nrf24l01p channelSettingOptionWord16 = Nrf24l01p (36);
	Nrf24l01p channelSettingOption16 = Nrf24l01p (37);
	Timer timeButtonSelect = Timer();
	unsigned long long timeButtonSelectPrevious = 0;
	Timer timeDisplay = Timer();
	unsigned long long timeDisplayPrevious = 0;
	Timer timeSound = Timer();
	unsigned long long timeSoundPrevious = 0;
	Timer timer = Timer();
	bool timerStarted = false;
	bool timerEnded = false;
	unsigned char brightness = 1;
	bool exit = false;
	bool lowVoltageBatteryControl = false;
	bool lowVoltageBatteryModel = false;
	Filter filterPotentiometerSetting = Filter (100);
	Filter filterVoltageBatteryControl = Filter (100);
	Filter filterVoltageBatteryModel = Filter (100);
	Filter filterTelemetryAuxiliary = Filter (100);
	Delay delayDisplaySoundStartCondition = Delay (1000, false);
	Delay delayDisplayLowVoltageBatteryControl = Delay (500, true);
	Delay delaySoundLowVoltageBatteryControl = Delay (200, true);
	Delay delayDisplayLowVoltageBatteryModel = Delay (500, true);
	Delay delaySoundLowVoltageBatteryModel = Delay (1000, true);
	Delay delayDisplayTimerEnded = Delay (500, true);
	Delay delaySoundTimerEnded = Delay (1000, true);
	Delay delayTrimThrottle = Delay (1000, false);
	Delay delayTrimPitch = Delay (1000, false);
	Delay delayTrimRoll = Delay (1000, false);
	Delay delayTrimYaw = Delay (1000, false);
	Hysteresis select = Hysteresis();
	unsigned char selectPrevious = 0;
	bool onAir = true;
	bool locked = false;
	unsigned char stateLocked = 0;
	bool menuSetting = false;
	unsigned char stateSettingTune = 2;
	const char *WORD_EXIT = "  exit  ";
	const char *WORD_UPDATE = " update ";
	unsigned char displayVoltageBatteryControl = 0;
	unsigned char displayVoltageBatteryModel = 0;
	unsigned char displayTimerEnded = 0;
	bool soundOnline = false;
	bool soundOffline = false;
	bool soundLowVoltageBatteryControl = false;
	unsigned char soundLowVoltageBatteryModel = 0;
	unsigned char soundTimerEnded = 0;
	bool soundLock = false;
	bool soundLocked = false;
	bool soundSelect = false;
	bool soundTimerStart = false;
	bool soundSwitch1 = false;
	bool soundSwitch2 = false;
	bool soundSwitch3 = false;
	bool soundTune = false;
	bool soundOk = false;
	bool soundNull = false;
	bool inhibitSound = true;
	const unsigned char TIME_SPACE_SOUND = 10;
	unsigned int throttle = 0;
	unsigned int pitch = 0;
	unsigned int roll = 0;
	unsigned int yaw = 0;
	bool cut = false;
	bool cutPrevious = false;
	unsigned char auxiliaryA = 0;
	unsigned char auxiliaryAPrevious = 0;
	unsigned char auxiliaryB = 0;
	unsigned char auxiliaryBPrevious = 0;
	unsigned char auxiliaryC = 0;
	unsigned char auxiliaryCPrevious = 0;
	unsigned int auxiliaryD = 0;
	unsigned char failSafe = 0;
	bool update = false;
	bool updated = false;
	bool exitUpdate = false;
	unsigned int settingBatteryModelLow = 0;
	unsigned int settingBatteryModelLowTune = 0;
	unsigned int settingTimerEnd = 0;
	unsigned int settingTimerEndTune = 0;
	unsigned int settingTimerTrigger = 0;
	unsigned int settingTimerTriggerTune = 0;
	unsigned char settingTrimThrottle = 0;
	unsigned char settingTrimPitch = 0;
	unsigned char settingTrimRoll = 0;
	unsigned char settingTrimYaw = 0;
	unsigned char settingOptionWord [16][4] = {{0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0}};
	unsigned int settingOption [16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned int settingOptionTune [16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned int settingOptionMin [16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned int settingOptionMax [16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	bool settingOptionCenter [16] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
	bool settingOptionDecimal [16] = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
	unsigned char mapSettingOption [16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char countSettingOption = 0;
	unsigned int settingTunePrevious = 0;
	const unsigned long SETUP_ID = 2244881769;
	const unsigned int SETUP_MIN_THROTTLE = 0;
	const unsigned int SETUP_MAX_THROTTLE = 1023;
	const unsigned int SETUP_MIN_PITCH = 0;
	const unsigned int SETUP_MAX_PITCH = 1023;
	const unsigned int SETUP_MIN_ROLL = 0;
	const unsigned int SETUP_MAX_ROLL = 1023;
	const unsigned int SETUP_MIN_YAW = 0;
	const unsigned int SETUP_MAX_YAW = 1023;
	
	switchPowerHold.on();
	
	SoundWrite::pin (4);
	
	SoundWrite::key (128, 100);
	SoundWrite::key (256, 100);
	SoundWrite::key (0, 50);
	SoundWrite::key (256, 100);
	SoundWrite::key (512, 100);
	SoundWrite::key (0, 50);
	SoundWrite::key (512, 100);
	SoundWrite::key (1024, 100);
	SoundWrite::playKey();
	
	for (n = 0; n < 4; n++)
	{
		display.clearDevice();
		display.draw (0b00110000, 4 - n);
		display.draw (0b00000110, 5 + n);
		Timer::pause (100);
		display.draw (0b00000110, 4 - n);
		display.draw (0b00110000, 5 + n);
		Timer::pause (100);
	}
	
	timeSound.start (0);
	
	while (exit == false)
	{
		timeSound.state();
		
		switchPowerState.read();
		potentiometerSelect.read();
		buttonSelect.read();
		switchCut.read();
		switchAuxiliaryA1.read();
		switchAuxiliaryA2.read();
		switchAuxiliaryB1.read();
		switchAuxiliaryB2.read();
		switchAuxiliaryC1.read();
		switchAuxiliaryC2.read();
		switchTrimThrottle1.read();
		switchTrimThrottle2.read();
		switchTrimPitch1.read();
		switchTrimPitch2.read();
		switchTrimRoll1.read();
		switchTrimRoll2.read();
		switchTrimYaw1.read();
		switchTrimYaw2.read();
		voltageBatteryControl.read();
		
		if (switchPowerState.continuous == true)
		{
			SoundWrite::key (1024, 100);
			SoundWrite::key (512, 100);
			SoundWrite::key (0, 50);
			SoundWrite::key (512, 100);
			SoundWrite::key (256, 100);
			SoundWrite::key (0, 50);
			SoundWrite::key (256, 100);
			SoundWrite::key (128, 100);
			SoundWrite::playKey();
			
			for (n = 0; n < 4; n++)
			{
				display.clearDevice();
				display.draw (0b00000110, 1 + n);
				display.draw (0b00110000, 8 - n);
				Timer::pause (100);
				display.draw (0b00110000, 1 + n);
				display.draw (0b00000110, 8 - n);
				Timer::pause (100);
			}
			
			display.clearDevice();
			
			switchPowerHold.off();
			
			Timer::pause (1000);
			
			display.brightness (1);
			display.word ("shutdown");
			
			for (n = 2; n < 16; n++)
			{
				Timer::pause (30);
				display.brightness (n);
			}
			
			while (true)
			{
			}
		}
		
		if (potentiometerSelect.value < 480 && selectPrevious == 1)
		{
			selectPrevious = 0;
			onAir = true;
			
			soundSelect = true;
		}
		else if (potentiometerSelect.value > 543 && selectPrevious == 0)
		{
			selectPrevious = 1;
			onAir = false;
			
			soundSelect = true;
		}
		
		if (buttonSelect.continuous == true)
		{
			exit = true;
			
			if (onAir == true)
			{
				soundOnline = true;
			}
			else
			{
				soundOffline = true;
			}
		}
		
		cut = switchCut.continuous;
		
		if (cut != cutPrevious)
		{
			cutPrevious = cut;
			
			if (cut == false)
			{
				soundSwitch1 = true;
			}
			else
			{
				soundSwitch2 = true;
			}
		}
		
		if (switchAuxiliaryA1.continuous == true)
		{
			auxiliaryA = 0;
		}
		else if (switchAuxiliaryA2.continuous == true)
		{
			auxiliaryA = 2;
		}
		else
		{
			auxiliaryA = 1;
		}
		
		if (auxiliaryA != auxiliaryAPrevious)
		{
			auxiliaryAPrevious = auxiliaryA;
			
			if (auxiliaryA == 0)
			{
				soundSwitch1 = true;
			}
			else if (auxiliaryA == 1)
			{
				soundSwitch2 = true;
			}
			else
			{
				soundSwitch3 = true;
			}
		}
		
		if (switchAuxiliaryB1.continuous == true)
		{
			auxiliaryB = 0;
		}
		else if (switchAuxiliaryB2.continuous == true)
		{
			auxiliaryB = 2;
		}
		else
		{
			auxiliaryB = 1;
		}
		
		if (auxiliaryB != auxiliaryBPrevious)
		{
			auxiliaryBPrevious = auxiliaryB;
			
			if (auxiliaryB == 0)
			{
				soundSwitch1 = true;
			}
			else if (auxiliaryB == 1)
			{
				soundSwitch2 = true;
			}
			else
			{
				soundSwitch3 = true;
			}
		}
		
		if (switchAuxiliaryC1.continuous == true)
		{
			auxiliaryC = 0;
		}
		else if (switchAuxiliaryC2.continuous == true)
		{
			auxiliaryC = 2;
		}
		else
		{
			auxiliaryC = 1;
		}
		
		if (auxiliaryC != auxiliaryCPrevious)
		{
			auxiliaryCPrevious = auxiliaryC;
			
			if (auxiliaryC == 0)
			{
				soundSwitch1 = true;
			}
			else if (auxiliaryC == 1)
			{
				soundSwitch2 = true;
			}
			else
			{
				soundSwitch3 = true;
			}
		}
		
		if (switchTrimThrottle1.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimThrottle2.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimThrottle1.continuous == true)
		{
			delayTrimThrottle.state();
			
			if (delayTrimThrottle.update == true)
			{
				soundNull = true;
				delayTrimThrottle.set (50);
			}
		}
		else if (switchTrimThrottle2.continuous == true)
		{
			delayTrimThrottle.state();
			
			if (delayTrimThrottle.update == true)
			{
				soundNull = true;
				delayTrimThrottle.set (50);
			}
		}
		else
		{
			delayTrimThrottle.set (1000);
		}
		
		if (switchTrimPitch1.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimPitch2.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimPitch1.continuous == true)
		{
			delayTrimPitch.state();
			
			if (delayTrimPitch.update == true)
			{
				soundNull = true;
				delayTrimPitch.set (50);
			}
		}
		else if (switchTrimPitch2.continuous == true)
		{
			delayTrimPitch.state();
			
			if (delayTrimPitch.update == true)
			{
				soundNull = true;
				delayTrimPitch.set (50);
			}
		}
		else
		{
			delayTrimPitch.set (1000);
		}
		
		if (switchTrimRoll1.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimRoll2.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimRoll1.continuous == true)
		{
			delayTrimRoll.state();
			
			if (delayTrimRoll.update == true)
			{
				soundNull = true;
				delayTrimRoll.set (50);
			}
		}
		else if (switchTrimRoll2.continuous == true)
		{
			delayTrimRoll.state();
			
			if (delayTrimRoll.update == true)
			{
				soundNull = true;
				delayTrimRoll.set (50);
			}
		}
		else
		{
			delayTrimRoll.set (1000);
		}
		
		if (switchTrimYaw1.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimYaw2.momentary == true)
		{
			soundNull = true;
		}
		else if (switchTrimYaw1.continuous == true)
		{
			delayTrimYaw.state();
			
			if (delayTrimYaw.update == true)
			{
				soundNull = true;
				delayTrimYaw.set (50);
			}
		}
		else if (switchTrimYaw2.continuous == true)
		{
			delayTrimYaw.state();
			
			if (delayTrimYaw.update == true)
			{
				soundNull = true;
				delayTrimYaw.set (50);
			}
		}
		else
		{
			delayTrimYaw.set (1000);
		}
		
		filterVoltageBatteryControl.set (voltageBatteryControl.value);
		
		if (lowVoltageBatteryControl == false && filterVoltageBatteryControl.value < 131)
		{
			lowVoltageBatteryControl = true;
			soundLowVoltageBatteryControl = true;
		}
		
		if (onAir == true)
		{
			display.word ("on air  ");
		}
		else
		{
			display.word ("off air ");
		}
		
		if (soundOnline == true)
		{
			SoundWrite::key (256, 100);
			SoundWrite::key (0, 50);
			SoundWrite::key (512, 100);
			SoundWrite::key (0, 50);
			SoundWrite::key (1024, 100);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 400ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundOffline == true)
		{
			SoundWrite::key (256, 100);
			SoundWrite::key (0, 50);
			SoundWrite::key (256, 100);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 250ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSelect == true && inhibitSound == false)
		{
			SoundWrite::play (1024, 20);
			timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundNull == true && inhibitSound == false)
		{
			SoundWrite::play (128, 200);
			timeSoundPrevious = timeSound.ms + 200ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSwitch1 == true && inhibitSound == false)
		{
			SoundWrite::play (1024, 20);
			timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSwitch2 == true && inhibitSound == false)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSwitch3 == true && inhibitSound == false)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 140ll + (long long)(TIME_SPACE_SOUND);
		}
		
		if (soundLowVoltageBatteryControl == true && timeSound.ms > timeSoundPrevious)
		{
			delaySoundLowVoltageBatteryControl.state();
			
			if (delaySoundLowVoltageBatteryControl.update == true)
			{
				SoundWrite::play (48, 100);
			}
		}
		
		soundSelect = false;
		soundOnline = false;
		soundOffline = false;
		soundNull = false;
		soundSwitch1 = false;
		soundSwitch2 = false;
		soundSwitch3 = false;
		
		inhibitSound = false;
	}
	
	if (onAir == true)
	{
		inhibitSound = true;
		
		Nrf24l01p::start (5, 32, SETUP_ID, false);
		
		while (onAir == true && (channelTelemetry.received == false || channelSettingBatteryTimer.received == false || channelSettingTrim.received == false || channelSettingOptionWord1.received == false || channelSettingOption1.received == false || channelSettingOptionWord2.received == false || channelSettingOption2.received == false || channelSettingOptionWord3.received == false || channelSettingOption3.received == false || channelSettingOptionWord4.received == false || channelSettingOption4.received == false || channelSettingOptionWord5.received == false || channelSettingOption5.received == false || channelSettingOptionWord6.received == false || channelSettingOption6.received == false || channelSettingOptionWord7.received == false || channelSettingOption7.received == false || channelSettingOptionWord8.received == false || channelSettingOption8.received == false || channelSettingOptionWord9.received == false || channelSettingOption9.received == false || channelSettingOptionWord10.received == false || channelSettingOption10.received == false || channelSettingOptionWord11.received == false || channelSettingOption11.received == false || channelSettingOptionWord12.received == false || channelSettingOption12.received == false || channelSettingOptionWord13.received == false || channelSettingOption13.received == false || channelSettingOptionWord14.received == false || channelSettingOption14.received == false || channelSettingOptionWord15.received == false || channelSettingOption15.received == false || channelSettingOptionWord16.received == false || channelSettingOption16.received == false))
		{
			timeSound.state();
			
			delayDisplaySoundStartCondition.state();
			
			switchPowerState.read();
			buttonSelect.read();
			switchCut.read();
			switchAuxiliaryA1.read();
			switchAuxiliaryA2.read();
			switchAuxiliaryB1.read();
			switchAuxiliaryB2.read();
			switchAuxiliaryC1.read();
			switchAuxiliaryC2.read();
			switchTrimThrottle1.read();
			switchTrimThrottle2.read();
			switchTrimPitch1.read();
			switchTrimPitch2.read();
			switchTrimRoll1.read();
			switchTrimRoll2.read();
			switchTrimYaw1.read();
			switchTrimYaw2.read();
			voltageBatteryControl.read();
			
			channelTelemetry.receive();
			
			channelSettingBatteryTimer.receive();
			channelSettingTrim.receive();
			channelSettingOptionWord1.receive();
			channelSettingOption1.receive();
			channelSettingOptionWord2.receive();
			channelSettingOption2.receive();
			channelSettingOptionWord3.receive();
			channelSettingOption3.receive();
			channelSettingOptionWord4.receive();
			channelSettingOption4.receive();
			channelSettingOptionWord5.receive();
			channelSettingOption5.receive();
			channelSettingOptionWord6.receive();
			channelSettingOption6.receive();
			channelSettingOptionWord7.receive();
			channelSettingOption7.receive();
			channelSettingOptionWord8.receive();
			channelSettingOption8.receive();
			channelSettingOptionWord9.receive();
			channelSettingOption9.receive();
			channelSettingOptionWord10.receive();
			channelSettingOption10.receive();
			channelSettingOptionWord11.receive();
			channelSettingOption11.receive();
			channelSettingOptionWord12.receive();
			channelSettingOption12.receive();
			channelSettingOptionWord13.receive();
			channelSettingOption13.receive();
			channelSettingOptionWord14.receive();
			channelSettingOption14.receive();
			channelSettingOptionWord15.receive();
			channelSettingOption15.receive();
			channelSettingOptionWord16.receive();
			channelSettingOption16.receive();
			
			if (switchPowerState.continuous == true)
			{
				SoundWrite::key (1024, 100);
				SoundWrite::key (512, 100);
				SoundWrite::key (0, 50);
				SoundWrite::key (512, 100);
				SoundWrite::key (256, 100);
				SoundWrite::key (0, 50);
				SoundWrite::key (256, 100);
				SoundWrite::key (128, 100);
				SoundWrite::playKey();
				
				for (n = 0; n < 4; n++)
				{
					display.clearDevice();
					display.draw (0b00000110, 1 + n);
					display.draw (0b00110000, 8 - n);
					Timer::pause (100);
					display.draw (0b00110000, 1 + n);
					display.draw (0b00000110, 8 - n);
					Timer::pause (100);
				}
				
				display.clearDevice();
				
				switchPowerHold.off();
				
				Timer::pause (1000);
				
				display.brightness (1);
				display.word ("shutdown");
				
				for (n = 2; n < 16; n++)
				{
					Timer::pause (30);
					display.brightness (n);
				}
				
				while (true)
				{
				}
			}
			
			if (delayDisplaySoundStartCondition.update == true)
			{
				exitUpdate = true;
			}
			
			if (buttonSelect.momentary == true)
			{
				if (exitUpdate == true)
				{
					onAir = false;
				}
				
				soundNull = true;
			}
			
			cut = switchCut.continuous;
			
			if (cut != cutPrevious)
			{
				cutPrevious = cut;
				
				if (cut == false)
				{
					soundSwitch1 = true;
				}
				else
				{
					soundSwitch2 = true;
				}
			}
			
			if (switchAuxiliaryA1.continuous == true)
			{
				auxiliaryA = 0;
			}
			else if (switchAuxiliaryA2.continuous == true)
			{
				auxiliaryA = 2;
			}
			else
			{
				auxiliaryA = 1;
			}
			
			if (auxiliaryA != auxiliaryAPrevious)
			{
				auxiliaryAPrevious = auxiliaryA;
				
				if (auxiliaryA == 0)
				{
					soundSwitch1 = true;
				}
				else if (auxiliaryA == 1)
				{
					soundSwitch2 = true;
				}
				else
				{
					soundSwitch3 = true;
				}
			}
			
			if (switchAuxiliaryB1.continuous == true)
			{
				auxiliaryB = 0;
			}
			else if (switchAuxiliaryB2.continuous == true)
			{
				auxiliaryB = 2;
			}
			else
			{
				auxiliaryB = 1;
			}
			
			if (auxiliaryB != auxiliaryBPrevious)
			{
				auxiliaryBPrevious = auxiliaryB;
				
				if (auxiliaryB == 0)
				{
					soundSwitch1 = true;
				}
				else if (auxiliaryB == 1)
				{
					soundSwitch2 = true;
				}
				else
				{
					soundSwitch3 = true;
				}
			}
			
			if (switchAuxiliaryC1.continuous == true)
			{
				auxiliaryC = 0;
			}
			else if (switchAuxiliaryC2.continuous == true)
			{
				auxiliaryC = 2;
			}
			else
			{
				auxiliaryC = 1;
			}
			
			if (auxiliaryC != auxiliaryCPrevious)
			{
				auxiliaryCPrevious = auxiliaryC;
				
				if (auxiliaryC == 0)
				{
					soundSwitch1 = true;
				}
				else if (auxiliaryC == 1)
				{
					soundSwitch2 = true;
				}
				else
				{
					soundSwitch3 = true;
				}
			}
			
			if (switchTrimThrottle1.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimThrottle2.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimThrottle1.continuous == true)
			{
				delayTrimThrottle.state();
				
				if (delayTrimThrottle.update == true)
				{
					soundNull = true;
					delayTrimThrottle.set (50);
				}
			}
			else if (switchTrimThrottle2.continuous == true)
			{
				delayTrimThrottle.state();
				
				if (delayTrimThrottle.update == true)
				{
					soundNull = true;
					delayTrimThrottle.set (50);
				}
			}
			else
			{
				delayTrimThrottle.set (1000);
			}
			
			if (switchTrimPitch1.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimPitch2.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimPitch1.continuous == true)
			{
				delayTrimPitch.state();
				
				if (delayTrimPitch.update == true)
				{
					soundNull = true;
					delayTrimPitch.set (50);
				}
			}
			else if (switchTrimPitch2.continuous == true)
			{
				delayTrimPitch.state();
				
				if (delayTrimPitch.update == true)
				{
					soundNull = true;
					delayTrimPitch.set (50);
				}
			}
			else
			{
				delayTrimPitch.set (1000);
			}
			
			if (switchTrimRoll1.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimRoll2.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimRoll1.continuous == true)
			{
				delayTrimRoll.state();
				
				if (delayTrimRoll.update == true)
				{
					soundNull = true;
					delayTrimRoll.set (50);
				}
			}
			else if (switchTrimRoll2.continuous == true)
			{
				delayTrimRoll.state();
				
				if (delayTrimRoll.update == true)
				{
					soundNull = true;
					delayTrimRoll.set (50);
				}
			}
			else
			{
				delayTrimRoll.set (1000);
			}
			
			if (switchTrimYaw1.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimYaw2.momentary == true)
			{
				soundNull = true;
			}
			else if (switchTrimYaw1.continuous == true)
			{
				delayTrimYaw.state();
				
				if (delayTrimYaw.update == true)
				{
					soundNull = true;
					delayTrimYaw.set (50);
				}
			}
			else if (switchTrimYaw2.continuous == true)
			{
				delayTrimYaw.state();
				
				if (delayTrimYaw.update == true)
				{
					soundNull = true;
					delayTrimYaw.set (50);
				}
			}
			else
			{
				delayTrimYaw.set (1000);
			}
			
			filterVoltageBatteryControl.set (voltageBatteryControl.value);
			
			if (lowVoltageBatteryControl == false && filterVoltageBatteryControl.value < 131)
			{
				lowVoltageBatteryControl = true;
				soundLowVoltageBatteryControl = true;
			}
			
			if (delayDisplaySoundStartCondition.update == true)
			{
				display.word ("binding ");
			}
			
			if (soundNull == true && inhibitSound == false)
			{
				SoundWrite::play (128, 200);
				timeSoundPrevious = timeSound.ms + 200ll + (long long)(TIME_SPACE_SOUND);
			}
			else if (soundSwitch1 == true && inhibitSound == false)
			{
				SoundWrite::play (1024, 20);
				timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
			}
			else if (soundSwitch2 == true && inhibitSound == false)
			{
				SoundWrite::key (1024, 20);
				SoundWrite::key (0, 40);
				SoundWrite::key (1024, 20);
				SoundWrite::playKey();
				
				timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
			}
			else if (soundSwitch3 == true && inhibitSound == false)
			{
				SoundWrite::key (1024, 20);
				SoundWrite::key (0, 40);
				SoundWrite::key (1024, 20);
				SoundWrite::key (0, 40);
				SoundWrite::key (1024, 20);
				SoundWrite::playKey();
				
				timeSoundPrevious = timeSound.ms + 140ll + (long long)(TIME_SPACE_SOUND);
			}
			else if (delayDisplaySoundStartCondition.update == true)
			{
				SoundWrite::key (128, 100);
				SoundWrite::key (0, 100);
				SoundWrite::key (128, 100);
				SoundWrite::playKey();
				
				timeSoundPrevious = timeSound.ms + 300ll + (long long)(TIME_SPACE_SOUND);
			}
			
			if (soundLowVoltageBatteryControl == true && timeSound.ms > timeSoundPrevious)
			{
				delaySoundLowVoltageBatteryControl.state();
				
				if (delaySoundLowVoltageBatteryControl.update == true)
				{
					SoundWrite::play (48, 100);
				}
			}
			
			soundNull = false;
			soundSwitch1 = false;
			soundSwitch2 = false;
			soundSwitch3 = false;
			
			inhibitSound = false;
		}
	}
	
	if (onAir == true)
	{
		if (exitUpdate == true)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
		}
		
		filterVoltageBatteryModel.set (Math::curve (0, channelTelemetry.data & 0b00000000000000000000001111111111, 1023, 0, 55, 0));
		filterTelemetryAuxiliary.set (float ((channelTelemetry.data & 0b01111111111111111111110000000000) >> 10) / 10.0);
		updated = (channelTelemetry.data & 0b10000000000000000000000000000000) >> 31;
		
		settingBatteryModelLow = channelSettingBatteryTimer.data & 0b00000000000000000000001111111111;
		settingTimerEnd = (channelSettingBatteryTimer.data & 0b00000000001111111111110000000000) >> 10;
		settingTimerTrigger = (channelSettingBatteryTimer.data & 0b11111111110000000000000000000000) >> 22;
		settingTrimThrottle = channelSettingTrim.data & 0b00000000000000000000000011111111;
		settingTrimPitch = (channelSettingTrim.data & 0b00000000000000001111111100000000) >> 8;
		settingTrimRoll = (channelSettingTrim.data & 0b00000000111111110000000000000000) >> 16;
		settingTrimYaw = (channelSettingTrim.data & 0b11111111000000000000000000000000) >> 24;
		settingOptionWord [0][0] = channelSettingOptionWord1.data & 0b00000000000000000000000011111111;
		settingOptionWord [0][1] = (channelSettingOptionWord1.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [0][2] = (channelSettingOptionWord1.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [0][3] = (channelSettingOptionWord1.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [0] = channelSettingOption1.data & 0b00000000000000000000001111111111;
		settingOptionMin [0] = (channelSettingOption1.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [0] = (channelSettingOption1.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [0] = (channelSettingOption1.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [0] = (channelSettingOption1.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [1][0] = channelSettingOptionWord2.data & 0b00000000000000000000000011111111;
		settingOptionWord [1][1] = (channelSettingOptionWord2.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [1][2] = (channelSettingOptionWord2.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [1][3] = (channelSettingOptionWord2.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [1] = channelSettingOption2.data & 0b00000000000000000000001111111111;
		settingOptionMin [1] = (channelSettingOption2.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [1] = (channelSettingOption2.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [1] = (channelSettingOption2.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [1] = (channelSettingOption2.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [2][0] = channelSettingOptionWord3.data & 0b00000000000000000000000011111111;
		settingOptionWord [2][1] = (channelSettingOptionWord3.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [2][2] = (channelSettingOptionWord3.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [2][3] = (channelSettingOptionWord3.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [2] = channelSettingOption3.data & 0b00000000000000000000001111111111;
		settingOptionMin [2] = (channelSettingOption3.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [2] = (channelSettingOption3.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [2] = (channelSettingOption3.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [2] = (channelSettingOption3.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [3][0] = channelSettingOptionWord4.data & 0b00000000000000000000000011111111;
		settingOptionWord [3][1] = (channelSettingOptionWord4.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [3][2] = (channelSettingOptionWord4.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [3][3] = (channelSettingOptionWord4.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [3] = channelSettingOption4.data & 0b00000000000000000000001111111111;
		settingOptionMin [3] = (channelSettingOption4.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [3] = (channelSettingOption4.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [3] = (channelSettingOption4.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [3] = (channelSettingOption4.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [4][0] = channelSettingOptionWord5.data & 0b00000000000000000000000011111111;
		settingOptionWord [4][1] = (channelSettingOptionWord5.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [4][2] = (channelSettingOptionWord5.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [4][3] = (channelSettingOptionWord5.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [4] = channelSettingOption5.data & 0b00000000000000000000001111111111;
		settingOptionMin [4] = (channelSettingOption5.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [4] = (channelSettingOption5.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [4] = (channelSettingOption5.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [4] = (channelSettingOption5.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [5][0] = channelSettingOptionWord6.data & 0b00000000000000000000000011111111;
		settingOptionWord [5][1] = (channelSettingOptionWord6.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [5][2] = (channelSettingOptionWord6.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [5][3] = (channelSettingOptionWord6.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [5] = channelSettingOption6.data & 0b00000000000000000000001111111111;
		settingOptionMin [5] = (channelSettingOption6.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [5] = (channelSettingOption6.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [5] = (channelSettingOption6.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [5] = (channelSettingOption6.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [6][0] = channelSettingOptionWord7.data & 0b00000000000000000000000011111111;
		settingOptionWord [6][1] = (channelSettingOptionWord7.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [6][2] = (channelSettingOptionWord7.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [6][3] = (channelSettingOptionWord7.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [6] = channelSettingOption7.data & 0b00000000000000000000001111111111;
		settingOptionMin [6] = (channelSettingOption7.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [6] = (channelSettingOption7.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [6] = (channelSettingOption7.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [6] = (channelSettingOption7.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [7][0] = channelSettingOptionWord8.data & 0b00000000000000000000000011111111;
		settingOptionWord [7][1] = (channelSettingOptionWord8.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [7][2] = (channelSettingOptionWord8.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [7][3] = (channelSettingOptionWord8.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [7] = channelSettingOption8.data & 0b00000000000000000000001111111111;
		settingOptionMin [7] = (channelSettingOption8.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [7] = (channelSettingOption8.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [7] = (channelSettingOption8.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [7] = (channelSettingOption8.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [8][0] = channelSettingOptionWord9.data & 0b00000000000000000000000011111111;
		settingOptionWord [8][1] = (channelSettingOptionWord9.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [8][2] = (channelSettingOptionWord9.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [8][3] = (channelSettingOptionWord9.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [8] = channelSettingOption9.data & 0b00000000000000000000001111111111;
		settingOptionMin [8] = (channelSettingOption9.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [8] = (channelSettingOption9.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [8] = (channelSettingOption9.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [8] = (channelSettingOption9.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [9][0] = channelSettingOptionWord10.data & 0b00000000000000000000000011111111;
		settingOptionWord [9][1] = (channelSettingOptionWord10.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [9][2] = (channelSettingOptionWord10.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [9][3] = (channelSettingOptionWord10.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [9] = channelSettingOption10.data & 0b00000000000000000000001111111111;
		settingOptionMin [9] = (channelSettingOption10.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [9] = (channelSettingOption10.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [9] = (channelSettingOption10.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [9] = (channelSettingOption10.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [10][0] = channelSettingOptionWord11.data & 0b00000000000000000000000011111111;
		settingOptionWord [10][1] = (channelSettingOptionWord11.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [10][2] = (channelSettingOptionWord11.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [10][3] = (channelSettingOptionWord11.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [10] = channelSettingOption11.data & 0b00000000000000000000001111111111;
		settingOptionMin [10] = (channelSettingOption11.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [10] = (channelSettingOption11.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [10] = (channelSettingOption11.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [10] = (channelSettingOption11.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [11][0] = channelSettingOptionWord12.data & 0b00000000000000000000000011111111;
		settingOptionWord [11][1] = (channelSettingOptionWord12.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [11][2] = (channelSettingOptionWord12.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [11][3] = (channelSettingOptionWord12.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [11] = channelSettingOption12.data & 0b00000000000000000000001111111111;
		settingOptionMin [11] = (channelSettingOption12.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [11] = (channelSettingOption12.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [11] = (channelSettingOption12.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [11] = (channelSettingOption12.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [12][0] = channelSettingOptionWord13.data & 0b00000000000000000000000011111111;
		settingOptionWord [12][1] = (channelSettingOptionWord13.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [12][2] = (channelSettingOptionWord13.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [12][3] = (channelSettingOptionWord13.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [12] = channelSettingOption13.data & 0b00000000000000000000001111111111;
		settingOptionMin [12] = (channelSettingOption13.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [12] = (channelSettingOption13.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [12] = (channelSettingOption13.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [12] = (channelSettingOption13.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [13][0] = channelSettingOptionWord14.data & 0b00000000000000000000000011111111;
		settingOptionWord [13][1] = (channelSettingOptionWord14.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [13][2] = (channelSettingOptionWord14.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [13][3] = (channelSettingOptionWord14.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [13] = channelSettingOption14.data & 0b00000000000000000000001111111111;
		settingOptionMin [13] = (channelSettingOption14.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [13] = (channelSettingOption14.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [13] = (channelSettingOption14.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [13] = (channelSettingOption14.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [14][0] = channelSettingOptionWord15.data & 0b00000000000000000000000011111111;
		settingOptionWord [14][1] = (channelSettingOptionWord15.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [14][2] = (channelSettingOptionWord15.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [14][3] = (channelSettingOptionWord15.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [14] = channelSettingOption15.data & 0b00000000000000000000001111111111;
		settingOptionMin [14] = (channelSettingOption15.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [14] = (channelSettingOption15.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [14] = (channelSettingOption15.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [14] = (channelSettingOption15.data & 0b10000000000000000000000000000000) >> 31;
		settingOptionWord [15][0] = channelSettingOptionWord16.data & 0b00000000000000000000000011111111;
		settingOptionWord [15][1] = (channelSettingOptionWord16.data & 0b00000000000000001111111100000000) >> 8;
		settingOptionWord [15][2] = (channelSettingOptionWord16.data & 0b00000000111111110000000000000000) >> 16;
		settingOptionWord [15][3] = (channelSettingOptionWord16.data & 0b11111111000000000000000000000000) >> 24;
		settingOption [15] = channelSettingOption16.data & 0b00000000000000000000001111111111;
		settingOptionMin [15] = (channelSettingOption16.data & 0b00000000000011111111110000000000) >> 10;
		settingOptionMax [15] = (channelSettingOption16.data & 0b00111111111100000000000000000000) >> 20;
		settingOptionCenter [15] = (channelSettingOption16.data & 0b01000000000000000000000000000000) >> 30;
		settingOptionDecimal [15] = (channelSettingOption16.data & 0b10000000000000000000000000000000) >> 31;
		
		for (n = 0; n < 16; n++)
		{
			if ((settingOptionWord [n][0] != 0 || settingOptionWord [n][1] != 0 || settingOptionWord [n][2] != 0 || settingOptionWord [n][3] != 0) && (settingOptionMin [n] < settingOptionMax [n]))
			{
				mapSettingOption [countSettingOption] = n;
				countSettingOption++;
			}
		}
	}
	else
	{
		settingTrimThrottle = 255;
		settingTrimPitch = 255;
		settingTrimRoll = 255;
		settingTrimYaw = 255;
	}
	
	for (n = 15; n > 0; n--)
	{
		display.brightness (n);
		Timer::pause (30);
	}
	
	inhibitSound = true;
	
	timeButtonSelect.start (0);
	timeDisplay.start (0);
	
	while (true)
	{
		timeButtonSelect.state();
		timeDisplay.state();
		timeSound.state();
		timer.state();
		
		switchPowerState.read();
		potentiometerSelect.read();
		buttonSelect.read();
		potentiometerThrottle.read();
		potentiometerPitch.read();
		potentiometerRoll.read();
		potentiometerYaw.read();
		switchCut.read();
		switchAuxiliaryA1.read();
		switchAuxiliaryA2.read();
		switchAuxiliaryB1.read();
		switchAuxiliaryB2.read();
		switchAuxiliaryC1.read();
		switchAuxiliaryC2.read();
		potentiometerAuxiliaryD.read();
		switchTrimThrottle1.read();
		switchTrimThrottle2.read();
		switchTrimPitch1.read();
		switchTrimPitch2.read();
		switchTrimRoll1.read();
		switchTrimRoll2.read();
		switchTrimYaw1.read();
		switchTrimYaw2.read();
		voltageBatteryControl.read();
		
		channelTelemetry.receive();
		
		channelThrottleRollAuxiliaryCAuxiliaryD.transmit ((signed long)(auxiliaryD) << 22 | (signed long)(auxiliaryC) << 20 | (signed long)(roll) << 10 | (signed long)(throttle));
		channelPitchYawCutAuxiliaryAAuxiliaryBFailSafeUpdate.transmit ((signed long)(update) << 31 | (signed long)(failSafe) << 25 | (signed long)(auxiliaryB) << 23 | (signed long)(auxiliaryA) << 21 | (signed long)(cut) << 20 | (signed long)(yaw) << 10 | (signed long)(pitch));
		
		filterVoltageBatteryModel.set (Math::curve (0, channelTelemetry.data & 0b00000000000000000000001111111111, 1023, 0, 55, 0));
		filterTelemetryAuxiliary.set (float ((channelTelemetry.data & 0b01111111111111111111110000000000) >> 10) / 10.0);
		updated = (channelTelemetry.data & 0b10000000000000000000000000000000) >> 31;
		
		if (settingTrimThrottle != 255)
		{
			throttle = Math::round (Math::wurve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, float (settingTrimThrottle) + 384.5, 1023, 0, 0));
		}
		else
		{
			throttle = Math::round (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, 1023, 0));
		}
		
		if (settingTrimPitch != 255)
		{
			pitch = Math::round (Math::wurve (SETUP_MIN_PITCH, potentiometerPitch.value, SETUP_MAX_PITCH, 0, float (settingTrimPitch) + 384.5, 1023, 0, 0));
		}
		else
		{
			pitch = Math::round (Math::curve (SETUP_MIN_PITCH, potentiometerPitch.value, SETUP_MAX_PITCH, 0, 1023, 0));
		}
		
		if (settingTrimRoll != 255)
		{
			roll = Math::round (Math::wurve (SETUP_MIN_ROLL, potentiometerRoll.value, SETUP_MAX_ROLL, 0, float (settingTrimRoll) + 384.5, 1023, 0, 0));
		}
		else
		{
			roll = Math::round (Math::curve (SETUP_MIN_ROLL, potentiometerRoll.value, SETUP_MAX_ROLL, 0, 1023, 0));
		}
		
		if (settingTrimYaw != 255)
		{
			yaw = Math::round (Math::wurve (SETUP_MIN_YAW, potentiometerYaw.value, SETUP_MAX_YAW, 0, float (settingTrimYaw) + 384.5, 1023, 0, 0));
		}
		else
		{
			yaw = Math::round (Math::curve (SETUP_MIN_YAW, potentiometerYaw.value, SETUP_MAX_YAW, 0, 1023, 0));
		}
		
		cut = switchCut.continuous;
		
		if (cut != cutPrevious)
		{
			cutPrevious = cut;
			
			if (cut == false)
			{
				soundSwitch1 = true;
			}
			else
			{
				soundSwitch2 = true;
			}
		}
		
		if (switchAuxiliaryA1.continuous == true)
		{
			auxiliaryA = 0;
		}
		else if (switchAuxiliaryA2.continuous == true)
		{
			auxiliaryA = 2;
		}
		else
		{
			auxiliaryA = 1;
		}
		
		if (auxiliaryA != auxiliaryAPrevious)
		{
			auxiliaryAPrevious = auxiliaryA;
			
			if (auxiliaryA == 0)
			{
				soundSwitch1 = true;
			}
			else if (auxiliaryA == 1)
			{
				soundSwitch2 = true;
			}
			else
			{
				soundSwitch3 = true;
			}
		}
		
		if (switchAuxiliaryB1.continuous == true)
		{
			auxiliaryB = 0;
		}
		else if (switchAuxiliaryB2.continuous == true)
		{
			auxiliaryB = 2;
		}
		else
		{
			auxiliaryB = 1;
		}
		
		if (auxiliaryB != auxiliaryBPrevious)
		{
			auxiliaryBPrevious = auxiliaryB;
			
			if (auxiliaryB == 0)
			{
				soundSwitch1 = true;
			}
			else if (auxiliaryB == 1)
			{
				soundSwitch2 = true;
			}
			else
			{
				soundSwitch3 = true;
			}
		}
		
		if (switchAuxiliaryC1.continuous == true)
		{
			auxiliaryC = 0;
		}
		else if (switchAuxiliaryC2.continuous == true)
		{
			auxiliaryC = 2;
		}
		else
		{
			auxiliaryC = 1;
		}
		
		if (auxiliaryC != auxiliaryCPrevious)
		{
			auxiliaryCPrevious = auxiliaryC;
			
			if (auxiliaryC == 0)
			{
				soundSwitch1 = true;
			}
			else if (auxiliaryC == 1)
			{
				soundSwitch2 = true;
			}
			else
			{
				soundSwitch3 = true;
			}
		}
		
		auxiliaryD = potentiometerAuxiliaryD.value;
		
		if (failSafe < 63)
		{
			failSafe++;
		}
		else
		{
			failSafe = 0;
		}
		
		if (locked == true || menuSetting == false)
		{
			if (switchTrimThrottle1.momentary == true)
			{
				if (settingTrimThrottle < 254 && buttonSelect.continuous == false)
				{
					settingTrimThrottle++;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimThrottle2.momentary == true)
			{
				if (settingTrimThrottle > 0 && settingTrimThrottle != 255 && buttonSelect.continuous == false)
				{
					settingTrimThrottle--;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimThrottle1.continuous == true)
			{
				delayTrimThrottle.state();
				
				if (delayTrimThrottle.update == true)
				{
					if (settingTrimThrottle < 254 && buttonSelect.continuous == false)
					{
						settingTrimThrottle++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimThrottle.set (50);
				}
			}
			else if (switchTrimThrottle2.continuous == true)
			{
				delayTrimThrottle.state();
				
				if (delayTrimThrottle.update == true)
				{
					if (settingTrimThrottle > 0 && settingTrimThrottle != 255 && buttonSelect.continuous == false)
					{
						settingTrimThrottle--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimThrottle.set (50);
				}
			}
			else
			{
				delayTrimThrottle.set (1000);
			}
			
			if (switchTrimPitch1.momentary == true)
			{
				if (settingTrimPitch < 254 && buttonSelect.continuous == false)
				{
					settingTrimPitch++;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimPitch2.momentary == true)
			{
				if (settingTrimPitch > 0 && settingTrimPitch != 255 && buttonSelect.continuous == false)
				{
					settingTrimPitch--;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimPitch1.continuous == true)
			{
				delayTrimPitch.state();
				
				if (delayTrimPitch.update == true)
				{
					if (settingTrimPitch < 254 && buttonSelect.continuous == false)
					{
						settingTrimPitch++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimPitch.set (50);
				}
			}
			else if (switchTrimPitch2.continuous == true)
			{
				delayTrimPitch.state();
				
				if (delayTrimPitch.update == true)
				{
					if (settingTrimPitch > 0 && settingTrimPitch != 255 && buttonSelect.continuous == false)
					{
						settingTrimPitch--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimPitch.set (50);
				}
			}
			else
			{
				delayTrimPitch.set (1000);
			}
			
			if (switchTrimRoll1.momentary == true)
			{
				if (settingTrimRoll < 254 && buttonSelect.continuous == false)
				{
					settingTrimRoll++;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimRoll2.momentary == true)
			{
				if (settingTrimRoll > 0 && settingTrimRoll != 255 && buttonSelect.continuous == false)
				{
					settingTrimRoll--;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimRoll1.continuous == true)
			{
				delayTrimRoll.state();
				
				if (delayTrimRoll.update == true)
				{
					if (settingTrimRoll < 254 && buttonSelect.continuous == false)
					{
						settingTrimRoll++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimRoll.set (50);
				}
			}
			else if (switchTrimRoll2.continuous == true)
			{
				delayTrimRoll.state();
				
				if (delayTrimRoll.update == true)
				{
					if (settingTrimRoll > 0 && settingTrimRoll != 255 && buttonSelect.continuous == false)
					{
						settingTrimRoll--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimRoll.set (50);
				}
			}
			else
			{
				delayTrimRoll.set (1000);
			}
			
			if (switchTrimYaw1.momentary == true)
			{
				if (settingTrimYaw < 254 && buttonSelect.continuous == false)
				{
					settingTrimYaw++;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimYaw2.momentary == true)
			{
				if (settingTrimYaw > 0 && settingTrimYaw != 255 && buttonSelect.continuous == false)
				{
					settingTrimYaw--;
					soundSwitch1 = true;
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimYaw1.continuous == true)
			{
				delayTrimYaw.state();
				
				if (delayTrimYaw.update == true)
				{
					if (settingTrimYaw < 254 && buttonSelect.continuous == false)
					{
						settingTrimYaw++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimYaw.set (50);
				}
			}
			else if (switchTrimYaw2.continuous == true)
			{
				delayTrimYaw.state();
				
				if (delayTrimYaw.update == true)
				{
					if (settingTrimYaw > 0 && settingTrimYaw != 255 && buttonSelect.continuous == false)
					{
						settingTrimYaw--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimYaw.set (50);
				}
			}
			else
			{
				delayTrimYaw.set (1000);
			}
		}
		else
		{
			if (switchTrimThrottle1.momentary == true || switchTrimPitch1.momentary == true || switchTrimRoll1.momentary == true || switchTrimYaw1.momentary == true)
			{
				if (select.value == 0)
				{
					if (settingBatteryModelLowTune < 1000 && buttonSelect.continuous == false)
					{
						settingBatteryModelLowTune++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else if (select.value == 1)
				{
					if (settingTimerEndTune < 3600 && buttonSelect.continuous == false)
					{
						settingTimerEndTune++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else if (select.value == 2)
				{
					if (settingTimerTriggerTune < 1023 && buttonSelect.continuous == false)
					{
						settingTimerTriggerTune++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else if (select.value - 3 < countSettingOption)
				{
					if (settingOptionTune [mapSettingOption [select.value - 3]] < settingOptionMax [mapSettingOption [select.value - 3]] && buttonSelect.continuous == false)
					{
						settingOptionTune [mapSettingOption [select.value - 3]]++;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimThrottle2.momentary == true || switchTrimPitch2.momentary == true || switchTrimRoll2.momentary == true || switchTrimYaw2.momentary == true)
			{
				if (select.value == 0)
				{
					if (settingBatteryModelLowTune > 0 && buttonSelect.continuous == false)
					{
						settingBatteryModelLowTune--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else if (select.value == 1)
				{
					if (settingTimerEndTune > 0 && buttonSelect.continuous == false)
					{
						settingTimerEndTune--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else if (select.value == 2)
				{
					if (settingTimerTriggerTune > 0 && buttonSelect.continuous == false)
					{
						settingTimerTriggerTune--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else if (select.value - 3 < countSettingOption)
				{
					if (settingOptionTune [mapSettingOption [select.value - 3]] > settingOptionMin [mapSettingOption [select.value - 3]] && buttonSelect.continuous == false)
					{
						settingOptionTune [mapSettingOption [select.value - 3]]--;
						soundSwitch1 = true;
					}
					else
					{
						soundNull = true;
					}
				}
				else
				{
					soundNull = true;
				}
			}
			else if (switchTrimThrottle1.continuous == true || switchTrimPitch1.continuous == true || switchTrimRoll1.continuous == true || switchTrimYaw1.continuous == true)
			{
				delayTrimThrottle.state();
				
				if (delayTrimThrottle.update == true)
				{
					if (select.value == 0)
					{
						if (settingBatteryModelLowTune < 1000 && buttonSelect.continuous == false)
						{
							settingBatteryModelLowTune++;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else if (select.value == 1)
					{
						if (settingTimerEndTune < 3600 && buttonSelect.continuous == false)
						{
							settingTimerEndTune++;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else if (select.value == 2)
					{
						if (settingTimerTriggerTune < 1023 && buttonSelect.continuous == false)
						{
							settingTimerTriggerTune++;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else if (select.value - 3 < countSettingOption)
					{
						if (settingOptionTune [mapSettingOption [select.value - 3]] < settingOptionMax [mapSettingOption [select.value - 3]] && buttonSelect.continuous == false)
						{
							settingOptionTune [mapSettingOption [select.value - 3]]++;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimThrottle.set (50);
				}
			}
			else if (switchTrimThrottle2.continuous == true || switchTrimPitch2.continuous == true || switchTrimRoll2.continuous == true || switchTrimYaw2.continuous == true)
			{
				delayTrimThrottle.state();
				
				if (delayTrimThrottle.update == true)
				{
					if (select.value == 0)
					{
						if (settingBatteryModelLowTune > 0 && buttonSelect.continuous == false)
						{
							settingBatteryModelLowTune--;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else if (select.value == 1)
					{
						if (settingTimerEndTune > 0 && buttonSelect.continuous == false)
						{
							settingTimerEndTune--;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else if (select.value == 2)
					{
						if (settingTimerTriggerTune > 0 && buttonSelect.continuous == false)
						{
							settingTimerTriggerTune--;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else if (select.value - 3 < countSettingOption)
					{
						if (settingOptionTune [mapSettingOption [select.value - 3]] > settingOptionMin [mapSettingOption [select.value - 3]] && buttonSelect.continuous == false)
						{
							settingOptionTune [mapSettingOption [select.value - 3]]--;
							soundSwitch1 = true;
						}
						else
						{
							soundNull = true;
						}
					}
					else
					{
						soundNull = true;
					}
					
					delayTrimThrottle.set (50);
				}
			}
			else
			{
				delayTrimThrottle.set (1000);
			}
		}
		
		if (switchPowerState.momentary == true)
		{
			if (select.value != 0 && locked == false)
			{
				SoundWrite::key (1024, 100);
				SoundWrite::key (512, 100);
				SoundWrite::key (0, 50);
				SoundWrite::key (512, 100);
				SoundWrite::key (256, 100);
				SoundWrite::key (0, 50);
				SoundWrite::key (256, 100);
				SoundWrite::key (128, 100);
				SoundWrite::playKey();
				
				for (n = 0; n < 4; n++)
				{
					display.clearDevice();
					display.draw (0b00000110, 1 + n);
					display.draw (0b00110000, 8 - n);
					Timer::pause (100);
					display.draw (0b00110000, 1 + n);
					display.draw (0b00000110, 8 - n);
					Timer::pause (100);
				}
				
				display.clearDevice();
				
				switchPowerHold.off();
				
				Timer::pause (1000);
				
				display.brightness (1);
				display.word ("shutdown");
				
				for (n = 2; n < 16; n++)
				{
					Timer::pause (30);
					display.brightness (n);
				}
				
				while (true)
				{
				}
			}
			else
			{
				soundNull = true;
			}
		}
		
		filterVoltageBatteryControl.set (voltageBatteryControl.value);
		
		if (lowVoltageBatteryControl == false && filterVoltageBatteryControl.value < 131)
		{
			lowVoltageBatteryControl = true;
			soundLowVoltageBatteryControl = true;
		}
		
		if (settingBatteryModelLow != 0)
		{
			if (lowVoltageBatteryModel == false && filterVoltageBatteryModel.value < float (settingBatteryModelLow) / 10.0)
			{
				lowVoltageBatteryModel = true;
				
				soundLowVoltageBatteryModel = 1;
				soundTimerEnded = 0;
			}
		}
		else if (lowVoltageBatteryModel == true)
		{
			lowVoltageBatteryModel = false;
			
			displayVoltageBatteryModel = 0;
			soundLowVoltageBatteryModel = 0;
		}
		
		if (settingTimerEnd != 0)
		{
			if (timerStarted == false && timerEnded == false && throttle >= settingTimerTrigger && settingTimerTrigger != 0)
			{
				timer.start (0);
				timerStarted = true;
				
				soundTimerStart = true;
			}
			else if (timerStarted == false && timerEnded == false && cut == false && settingTimerTrigger == 0)
			{
				timer.start (0);
				timerStarted = true;
				
				soundTimerStart = true;
			}
			else if (timerStarted == true && ((settingTimerEnd >= 5 && timer.s >= (long long)(settingTimerEnd) - 5ll) || (settingTimerEnd < 5 && timer.s >= 0)))
			{
				timerStarted = false;
				timerEnded = true;
				
				if (lowVoltageBatteryModel == false || (lowVoltageBatteryModel == true && soundLowVoltageBatteryModel == 7))
				{
					if (settingTimerEnd >= 5 && timer.s >= (long long)(settingTimerEnd) - 5ll)
					{
						soundTimerEnded = 1;
					}
					else
					{
						soundTimerEnded = 6 - settingTimerEnd;
					}
				}
			}
		}
		else if (timerStarted == true || timerEnded == true)
		{
			timer.stop();
			
			timerStarted = false;
			timerEnded = false;
			
			displayTimerEnded = 0;
			soundTimerEnded = 0;
		}
		
		if (menuSetting == false)
		{
			select.set (Math::curve (0, potentiometerSelect.value, 1023, 0, 9, 0));
			
			if (select.value != 0)
			{
				stateLocked = 2;
			}
			
			if (select.value != selectPrevious)
			{
				selectPrevious = select.value;
				
				if (lowVoltageBatteryControl == true)
				{
					delayDisplayLowVoltageBatteryControl.reset();
					displayVoltageBatteryControl = 1;
				}
				
				if (lowVoltageBatteryModel == true)
				{
					delayDisplayLowVoltageBatteryModel.reset();
					displayVoltageBatteryModel = 1;
				}
				
				if (timerEnded == true)
				{
					delayDisplayTimerEnded.reset();
					displayTimerEnded = 1;
				}
				
				soundSelect = true;
			}
			
			if (select.value == 0)
			{
				if (locked == false)
				{
					display.word (". lock  ");
				}
				else
				{
					display.word ("-.locked-");
				}
			}
			else if (select.value == 1)
			{
				if (lowVoltageBatteryControl == false)
				{
					display.word ("ct.rl/");
				}
				else
				{
					delayDisplayLowVoltageBatteryControl.state();
					
					if (delayDisplayLowVoltageBatteryControl.update == true)
					{
						if (displayVoltageBatteryControl == 0)
						{
							displayVoltageBatteryControl = 1;
							display.word ("--.--/");
						}
						else
						{
							displayVoltageBatteryControl = 0;
							display.word ("ct.rl/");
						}
					}
				}
				
				display.decimal (Math::curve (0, filterVoltageBatteryControl.value, 1023, 0, 55, 0), 5, 8, 1, true);
			}
			else if (select.value == 2)
			{
				if (lowVoltageBatteryModel == false)
				{
					display.word ("mod.l/");
				}
				else
				{
					delayDisplayLowVoltageBatteryModel.state();
					
					if (delayDisplayLowVoltageBatteryModel.update == true)
					{
						if (displayVoltageBatteryModel == 0)
						{
							displayVoltageBatteryModel = 1;
							display.word ("---.-/");
						}
						else
						{
							displayVoltageBatteryModel = 0;
							display.word ("mod.l/");
						}
					}
				}
				
				display.decimal (filterVoltageBatteryModel.value, 5, 8, 1, true);
			}
			else if (select.value == 3)
			{
				if (settingTimerEnd == 0)
				{
					display.word ("time. off");
				}
				else
				{
					if (timerEnded == false)
					{
						display.word ("time./");
					}
					else
					{
						delayDisplayTimerEnded.state();
						
						if (delayDisplayTimerEnded.update == true)
						{
							if (displayTimerEnded == 0)
							{
								displayTimerEnded = 1;
								display.word ("----./");
							}
							else
							{
								displayTimerEnded = 0;
								display.word ("time./");
							}
						}
					}
					
					display.integer (timer.s, 5, 8, true);
				}
			}
			else if (select.value == 4)
			{
				if (settingTrimThrottle == 255)
				{
					display.word ("t.hro off");
				}
				else
				{
					display.word ("t.hro/");
					display.integer (settingTrimThrottle - 127, 5, 8, true);
				}
			}
			else if (select.value == 5)
			{
				if (settingTrimPitch == 255)
				{
					display.word ("pi.tc off");
				}
				else
				{
					display.word ("pi.tc/");
					display.integer (settingTrimPitch - 127, 5, 8, true);
				}
			}
			else if (select.value == 6)
			{
				if (settingTrimRoll == 255)
				{
					display.word ("rol.l off");
				}
				else
				{
					display.word ("rol.l/");
					display.integer (settingTrimRoll - 127, 5, 8, true);
				}
			}
			else if (select.value == 7)
			{
				if (settingTrimYaw == 255)
				{
					display.word ("yaw . off");
				}
				else
				{
					display.word ("yaw ./");
					display.integer (settingTrimYaw - 127, 5, 8, true);
				}
			}
			else if (select.value == 8)
			{
				if (filterTelemetryAuxiliary.value == 0)
				{
					display.word ("t.lm  off");
				}
				else
				{
					display.word ("t.lm/");
					display.decimal (filterTelemetryAuxiliary.value, 4, 8, 1, true);
				}
			}
			else
			{
				display.word ("se.ttings");
			}
			
			if (select.value == 0)
			{
				if (buttonSelect.continuous == true)
				{
					if (switchPowerState.continuous == false)
					{
						if (stateLocked == 0)
						{
							timeButtonSelectPrevious = timeButtonSelect.ms;
							stateLocked = 1;
						}
						else if (stateLocked == 1 && timeButtonSelect.ms >= timeButtonSelectPrevious + 1000ll)
						{
							if (locked == false)
							{
								locked = true;
								soundLocked = true;
							}
							else
							{
								locked = false;
								soundLock = true;
							}
							
							stateLocked = 2;
						}
					}
					else if (buttonSelect.momentary == true)
					{
						soundNull = true;
					}
				}
				else
				{
					stateLocked = 0;
				}
			}
			else if (select.value == 1)
			{
				if (buttonSelect.momentary == true)
				{
					if (lowVoltageBatteryControl == true && soundLowVoltageBatteryControl == true)
					{
						soundLowVoltageBatteryControl = false;
						soundOk = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 2)
			{
				if (buttonSelect.momentary == true)
				{
					if (lowVoltageBatteryModel == true && filterVoltageBatteryModel.value >= float (settingBatteryModelLow) / 10.0)
					{
						lowVoltageBatteryModel = false;
						
						displayVoltageBatteryModel = 0;
						soundLowVoltageBatteryModel = 0;
						soundOk = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 3)
			{
				if (buttonSelect.momentary == true)
				{
					if (timerStarted == true || timerEnded == true)
					{
						timer.stop();
						
						timerStarted = false;
						timerEnded = false;
						
						displayTimerEnded = 0;
						soundTimerEnded = 0;
						soundOk = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 4)
			{
				if (buttonSelect.momentary == true)
				{
					if (onAir == true && locked == false)
					{
						if (settingTrimThrottle == 255)
						{
							settingTrimThrottle = 127;
						}
						else
						{
							settingTrimThrottle = 255;
						}
						
						delayTrimThrottle.set (1000);
						
						soundSwitch2 = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 5)
			{
				if (buttonSelect.momentary == true)
				{
					if (onAir == true && locked == false)
					{
						if (settingTrimPitch == 255)
						{
							settingTrimPitch = 127;
						}
						else
						{
							settingTrimPitch = 255;
						}
						
						delayTrimPitch.set (1000);
						
						soundSwitch2 = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 6)
			{
				if (buttonSelect.momentary == true)
				{
					if (onAir == true && locked == false)
					{
						if (settingTrimRoll == 255)
						{
							settingTrimRoll = 127;
						}
						else
						{
							settingTrimRoll = 255;
						}
						
						delayTrimRoll.set (1000);
						
						soundSwitch2 = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 7)
			{
				if (buttonSelect.momentary == true)
				{
					if (onAir == true && locked == false)
					{
						if (settingTrimYaw == 255)
						{
							settingTrimYaw = 127;
						}
						else
						{
							settingTrimYaw = 255;
						}
						
						delayTrimYaw.set (1000);
						
						soundSwitch2 = true;
					}
					else
					{
						soundNull = true;
					}
				}
			}
			else if (select.value == 9)
			{
				if (buttonSelect.momentary == true)
				{
					menuSetting = true;
					
					settingBatteryModelLowTune = settingBatteryModelLow;
					settingTimerEndTune = settingTimerEnd;
					settingTimerTriggerTune = settingTimerTrigger;
					
					for (n = 0; n < countSettingOption; n++)
					{
						settingOptionTune [mapSettingOption [n]] = settingOption [mapSettingOption [n]];
					}
					
					stateSettingTune = 2;
					
					delayTrimThrottle.set (1000);
					delayTrimPitch.set (1000);
					delayTrimRoll.set (1000);
					delayTrimYaw.set (1000);
					
					select.set (Math::curve (0, potentiometerSelect.value, 1023, 0, countSettingOption + 4, 0));
					selectPrevious = select.value;
					
					soundSwitch2 = true;
				}
			}
			else if (buttonSelect.momentary == true)
			{
				soundNull = true;
			}
		}
		else
		{
			select.set (Math::curve (0, potentiometerSelect.value, 1023, 0, countSettingOption + 4, 0));
			
			if (select.value != selectPrevious)
			{
				selectPrevious = select.value;
				
				stateSettingTune = 2;
				
				delayTrimThrottle.set (1000);
				delayTrimPitch.set (1000);
				delayTrimRoll.set (1000);
				delayTrimYaw.set (1000);
				
				soundSelect = true;
			}
			
			if (select.value == 0)
			{
				if (settingBatteryModelLowTune == 0)
				{
					display.word ("b.mdl off");
				}
				else
				{
					display.word ("b.mdl/");
					display.decimal (float (settingBatteryModelLowTune) / 10.0, 5, 8, 1, true);
				}
			}
			else if (select.value == 1)
			{
				if (settingTimerEndTune == 0)
				{
					display.word ("tm.ed off");
				}
				else
				{
					display.word ("tm.ed/");
					display.integer (settingTimerEndTune, 5, 8, true);
				}
			}
			else if (select.value == 2)
			{
				if (settingTimerTriggerTune == 0)
				{
					display.word ("tmt.r cut");
				}
				else
				{
					display.word ("tmt.r/");
					display.integer (settingTimerTriggerTune, 5, 8, true);
				}
			}
			else if (select.value - 3 < countSettingOption)
			{
				for (n = 0; n < 4; n++)
				{
					if (n == select.value % 4)
					{
						display.draw (settingOptionWord [mapSettingOption [select.value - 3]][n] | 0b10000000, n + 1);
					}
					else
					{
						display.draw (settingOptionWord [mapSettingOption [select.value - 3]][n], n + 1);
					}
				}
				
				if (settingOptionCenter [mapSettingOption [select.value - 3]] == false)
				{
					if (settingOptionDecimal [mapSettingOption [select.value - 3]] == false)
					{
						display.integer (settingOptionTune [mapSettingOption [select.value - 3]], 5, 8, true);
					}
					else
					{
						display.decimal (float (settingOptionTune [mapSettingOption [select.value - 3]]) / 10.0, 5, 8, 1, true);
					}
				}
				else
				{
					if (settingOptionDecimal [mapSettingOption [select.value - 3]] == false)
					{
						display.integer (settingOptionTune [mapSettingOption [select.value - 3]] - Math::round (Math::center (settingOptionMin [mapSettingOption [select.value - 3]], settingOptionMax [mapSettingOption [select.value - 3]])), 5, 8, true);
					}
					else
					{
						display.decimal ((float (settingOptionTune [mapSettingOption [select.value - 3]]) - float (Math::round (Math::center (settingOptionMin [mapSettingOption [select.value - 3]], settingOptionMax [mapSettingOption [select.value - 3]])))) / 10.0, 5, 8, 1, true);
					}
				}
			}
			else if (select.value - 3 == countSettingOption)
			{
				for (n = 0; n < 8; n++)
				{
					if (n == select.value % 4)
					{
						display.draw (Tool::characterToByte (&WORD_EXIT [n]) | 0b10000000, n + 1);
					}
					else
					{
						display.draw (Tool::characterToByte (&WORD_EXIT [n]), n + 1);
					}
				}
			}
			else
			{
				for (n = 0; n < 8; n++)
				{
					if (n == select.value % 4)
					{
						display.draw (Tool::characterToByte (&WORD_UPDATE [n]) | 0b10000000, n + 1);
					}
					else
					{
						display.draw (Tool::characterToByte (&WORD_UPDATE [n]), n + 1);
					}
				}
			}
			
			if (select.value == 0)
			{
				if (buttonSelect.continuous == true && stateSettingTune == 0)
				{
					stateSettingTune = 1;
					filterPotentiometerSetting.reset();
					
					settingTunePrevious = settingBatteryModelLowTune;
					
					soundSwitch3 = true;
				}
				else if (buttonSelect.continuous == true && stateSettingTune == 1)
				{
					filterPotentiometerSetting.set (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, 1000, 0));
					settingBatteryModelLowTune = Math::round (filterPotentiometerSetting.value);
					
					if (settingBatteryModelLowTune != settingTunePrevious)
					{
						settingTunePrevious = settingBatteryModelLowTune;
						soundTune = true;
					}
				}
				else if (buttonSelect.continuous == false)
				{
					stateSettingTune = 0;
				}
			}
			else if (select.value == 1)
			{
				if (buttonSelect.continuous == true && stateSettingTune == 0)
				{
					stateSettingTune = 1;
					filterPotentiometerSetting.reset();
					
					settingTunePrevious = settingTimerEndTune;
					
					soundSwitch3 = true;
				}
				else if (buttonSelect.continuous == true && stateSettingTune == 1)
				{
					filterPotentiometerSetting.set (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, 3600, 0));
					settingTimerEndTune = Math::round (filterPotentiometerSetting.value);
					
					if (settingTimerEndTune != settingTunePrevious)
					{
						settingTunePrevious = settingTimerEndTune;
						soundTune = true;
					}
				}
				else if (buttonSelect.continuous == false)
				{
					stateSettingTune = 0;
				}
			}
			else if (select.value == 2)
			{
				if (buttonSelect.continuous == true && stateSettingTune == 0)
				{
					stateSettingTune = 1;
					filterPotentiometerSetting.reset();
					
					settingTunePrevious = settingTimerTriggerTune;
					
					soundSwitch3 = true;
				}
				else if (buttonSelect.continuous == true && stateSettingTune == 1)
				{
					filterPotentiometerSetting.set (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, 1023, 0));
					settingTimerTriggerTune = Math::round (filterPotentiometerSetting.value);
					
					if (settingTimerTriggerTune != settingTunePrevious)
					{
						settingTunePrevious = settingTimerTriggerTune;
						soundTune = true;
					}
				}
				else if (buttonSelect.continuous == false)
				{
					stateSettingTune = 0;
				}
			}
			else if (select.value - 3 < countSettingOption)
			{
				if (buttonSelect.continuous == true && stateSettingTune == 0)
				{
					stateSettingTune = 1;
					filterPotentiometerSetting.reset();
					
					settingTunePrevious = settingOptionTune [mapSettingOption [select.value - 3]];
					
					soundSwitch3 = true;
				}
				else if (buttonSelect.continuous == true && stateSettingTune == 1)
				{
					filterPotentiometerSetting.set (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, settingOptionMin [mapSettingOption [select.value - 3]], settingOptionMax [mapSettingOption [select.value - 3]], 0));
					settingOptionTune [mapSettingOption [select.value - 3]] = Math::round (filterPotentiometerSetting.value);
					
					if (settingOptionTune [mapSettingOption [select.value - 3]] != settingTunePrevious)
					{
						settingTunePrevious = settingOptionTune [mapSettingOption [select.value - 3]];
						soundTune = true;
					}
				}
				else if (buttonSelect.continuous == false)
				{
					stateSettingTune = 0;
				}
			}
			else if (select.value - 3 == countSettingOption)
			{
				if (buttonSelect.momentary == true)
				{
					menuSetting = false;
					
					stateLocked = 2;
					
					delayTrimThrottle.set (1000);
					delayTrimPitch.set (1000);
					delayTrimRoll.set (1000);
					delayTrimYaw.set (1000);
					
					if (lowVoltageBatteryControl == true)
					{
						delayDisplayLowVoltageBatteryControl.reset();
						displayVoltageBatteryControl = 1;
					}
					
					if (lowVoltageBatteryModel == true)
					{
						delayDisplayLowVoltageBatteryModel.reset();
						displayVoltageBatteryModel = 1;
					}
					
					if (timerEnded == true)
					{
						delayDisplayTimerEnded.reset();
						displayTimerEnded = 1;
					}
					
					select.set (Math::curve (0, potentiometerSelect.value, 1023, 0, 9, 0));
					selectPrevious = select.value;
					
					soundNull = true;
				}
			}
			else
			{
				if (buttonSelect.momentary == true)
				{
					if (onAir == true && locked == false)
					{
						SoundWrite::key (1024, 20);
						SoundWrite::key (0, 40);
						SoundWrite::key (1024, 20);
						SoundWrite::key (0, 40);
						SoundWrite::key (1024, 20);
						SoundWrite::playKey();
						
						timeSoundPrevious = timeSound.ms + 140ll + (long long)(TIME_SPACE_SOUND);
						
						exit = false;
						exitUpdate = false;
						
						delayDisplaySoundStartCondition.reset();
						
						inhibitSound = true;
						
						while (updated == true && exit == false)
						{
							timeSound.state();
							
							delayDisplaySoundStartCondition.state();
							
							switchPowerState.read();
							buttonSelect.read();
							potentiometerThrottle.read();
							potentiometerPitch.read();
							potentiometerRoll.read();
							potentiometerYaw.read();
							switchCut.read();
							switchAuxiliaryA1.read();
							switchAuxiliaryA2.read();
							switchAuxiliaryB1.read();
							switchAuxiliaryB2.read();
							switchAuxiliaryC1.read();
							switchAuxiliaryC2.read();
							potentiometerAuxiliaryD.read();
							switchTrimThrottle1.read();
							switchTrimThrottle2.read();
							switchTrimPitch1.read();
							switchTrimPitch2.read();
							switchTrimRoll1.read();
							switchTrimRoll2.read();
							switchTrimYaw1.read();
							switchTrimYaw2.read();
							voltageBatteryControl.read();
							
							channelTelemetry.receive();
							
							channelThrottleRollAuxiliaryCAuxiliaryD.transmit ((signed long)(auxiliaryD) << 22 | (signed long)(auxiliaryC) << 20 | (signed long)(roll) << 10 | (signed long)(throttle));
							channelPitchYawCutAuxiliaryAAuxiliaryBFailSafeUpdate.transmit ((signed long)(update) << 31 | (signed long)(failSafe) << 25 | (signed long)(auxiliaryB) << 23 | (signed long)(auxiliaryA) << 21 | (signed long)(cut) << 20 | (signed long)(yaw) << 10 | (signed long)(pitch));
							
							if (switchPowerState.momentary == true)
							{
								if (locked == false)
								{
									SoundWrite::key (1024, 100);
									SoundWrite::key (512, 100);
									SoundWrite::key (0, 50);
									SoundWrite::key (512, 100);
									SoundWrite::key (256, 100);
									SoundWrite::key (0, 50);
									SoundWrite::key (256, 100);
									SoundWrite::key (128, 100);
									SoundWrite::playKey();
									
									for (n = 0; n < 4; n++)
									{
										display.clearDevice();
										display.draw (0b00000110, 1 + n);
										display.draw (0b00110000, 8 - n);
										Timer::pause (100);
										display.draw (0b00110000, 1 + n);
										display.draw (0b00000110, 8 - n);
										Timer::pause (100);
									}
									
									display.clearDevice();
									
									switchPowerHold.off();
									
									Timer::pause (1000);
									
									display.brightness (1);
									display.word ("shutdown");
									
									for (n = 2; n < 16; n++)
									{
										Timer::pause (30);
										display.brightness (n);
									}
									
									while (true)
									{
									}
								}
								else
								{
									soundNull = true;
								}
							}
							
							if (delayDisplaySoundStartCondition.update == true)
							{
								exitUpdate = true;
							}
							
							if (buttonSelect.momentary == true)
							{
								if (exitUpdate == true)
								{
									exit = true;
								}
								
								soundNull = true;
							}
							
							if (settingTrimThrottle != 255)
							{
								throttle = Math::round (Math::wurve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, float (settingTrimThrottle) + 384.5, 1023, 0, 0));
							}
							else
							{
								throttle = Math::round (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, 1023, 0));
							}
							
							if (settingTrimPitch != 255)
							{
								pitch = Math::round (Math::wurve (SETUP_MIN_PITCH, potentiometerPitch.value, SETUP_MAX_PITCH, 0, float (settingTrimPitch) + 384.5, 1023, 0, 0));
							}
							else
							{
								pitch = Math::round (Math::curve (SETUP_MIN_PITCH, potentiometerPitch.value, SETUP_MAX_PITCH, 0, 1023, 0));
							}
							
							if (settingTrimRoll != 255)
							{
								roll = Math::round (Math::wurve (SETUP_MIN_ROLL, potentiometerRoll.value, SETUP_MAX_ROLL, 0, float (settingTrimRoll) + 384.5, 1023, 0, 0));
							}
							else
							{
								roll = Math::round (Math::curve (SETUP_MIN_ROLL, potentiometerRoll.value, SETUP_MAX_ROLL, 0, 1023, 0));
							}
							
							if (settingTrimYaw != 255)
							{
								yaw = Math::round (Math::wurve (SETUP_MIN_YAW, potentiometerYaw.value, SETUP_MAX_YAW, 0, float (settingTrimYaw) + 384.5, 1023, 0, 0));
							}
							else
							{
								yaw = Math::round (Math::curve (SETUP_MIN_YAW, potentiometerYaw.value, SETUP_MAX_YAW, 0, 1023, 0));
							}
							
							cut = switchCut.continuous;
							
							if (cut != cutPrevious)
							{
								cutPrevious = cut;
								
								if (cut == false)
								{
									soundSwitch1 = true;
								}
								else
								{
									soundSwitch2 = true;
								}
							}
							
							if (switchAuxiliaryA1.continuous == true)
							{
								auxiliaryA = 0;
							}
							else if (switchAuxiliaryA2.continuous == true)
							{
								auxiliaryA = 2;
							}
							else
							{
								auxiliaryA = 1;
							}
							
							if (auxiliaryA != auxiliaryAPrevious)
							{
								auxiliaryAPrevious = auxiliaryA;
								
								if (auxiliaryA == 0)
								{
									soundSwitch1 = true;
								}
								else if (auxiliaryA == 1)
								{
									soundSwitch2 = true;
								}
								else
								{
									soundSwitch3 = true;
								}
							}
							
							if (switchAuxiliaryB1.continuous == true)
							{
								auxiliaryB = 0;
							}
							else if (switchAuxiliaryB2.continuous == true)
							{
								auxiliaryB = 2;
							}
							else
							{
								auxiliaryB = 1;
							}
							
							if (auxiliaryB != auxiliaryBPrevious)
							{
								auxiliaryBPrevious = auxiliaryB;
								
								if (auxiliaryB == 0)
								{
									soundSwitch1 = true;
								}
								else if (auxiliaryB == 1)
								{
									soundSwitch2 = true;
								}
								else
								{
									soundSwitch3 = true;
								}
							}
							
							if (switchAuxiliaryC1.continuous == true)
							{
								auxiliaryC = 0;
							}
							else if (switchAuxiliaryC2.continuous == true)
							{
								auxiliaryC = 2;
							}
							else
							{
								auxiliaryC = 1;
							}
							
							if (auxiliaryC != auxiliaryCPrevious)
							{
								auxiliaryCPrevious = auxiliaryC;
								
								if (auxiliaryC == 0)
								{
									soundSwitch1 = true;
								}
								else if (auxiliaryC == 1)
								{
									soundSwitch2 = true;
								}
								else
								{
									soundSwitch3 = true;
								}
							}
							
							auxiliaryD = potentiometerAuxiliaryD.value;
							
							if (failSafe < 63)
							{
								failSafe++;
							}
							else
							{
								failSafe = 0;
							}
							
							filterVoltageBatteryModel.set (Math::curve (0, channelTelemetry.data & 0b00000000000000000000001111111111, 1023, 0, 55, 0));
							filterTelemetryAuxiliary.set (float ((channelTelemetry.data & 0b01111111111111111111110000000000) >> 10) / 10.0);
							updated = (channelTelemetry.data & 0b10000000000000000000000000000000) >> 31;
							
							if (switchTrimThrottle1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimThrottle2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimThrottle1.continuous == true)
							{
								delayTrimThrottle.state();
								
								if (delayTrimThrottle.update == true)
								{
									soundNull = true;
									delayTrimThrottle.set (50);
								}
							}
							else if (switchTrimThrottle2.continuous == true)
							{
								delayTrimThrottle.state();
								
								if (delayTrimThrottle.update == true)
								{
									soundNull = true;
									delayTrimThrottle.set (50);
								}
							}
							else
							{
								delayTrimThrottle.set (1000);
							}
							
							if (switchTrimPitch1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimPitch2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimPitch1.continuous == true)
							{
								delayTrimPitch.state();
								
								if (delayTrimPitch.update == true)
								{
									soundNull = true;
									delayTrimPitch.set (50);
								}
							}
							else if (switchTrimPitch2.continuous == true)
							{
								delayTrimPitch.state();
								
								if (delayTrimPitch.update == true)
								{
									soundNull = true;
									delayTrimPitch.set (50);
								}
							}
							else
							{
								delayTrimPitch.set (1000);
							}
							
							if (switchTrimRoll1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimRoll2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimRoll1.continuous == true)
							{
								delayTrimRoll.state();
								
								if (delayTrimRoll.update == true)
								{
									soundNull = true;
									delayTrimRoll.set (50);
								}
							}
							else if (switchTrimRoll2.continuous == true)
							{
								delayTrimRoll.state();
								
								if (delayTrimRoll.update == true)
								{
									soundNull = true;
									delayTrimRoll.set (50);
								}
							}
							else
							{
								delayTrimRoll.set (1000);
							}
							
							if (switchTrimYaw1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimYaw2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimYaw1.continuous == true)
							{
								delayTrimYaw.state();
								
								if (delayTrimYaw.update == true)
								{
									soundNull = true;
									delayTrimYaw.set (50);
								}
							}
							else if (switchTrimYaw2.continuous == true)
							{
								delayTrimYaw.state();
								
								if (delayTrimYaw.update == true)
								{
									soundNull = true;
									delayTrimYaw.set (50);
								}
							}
							else
							{
								delayTrimYaw.set (1000);
							}
							
							filterVoltageBatteryControl.set (voltageBatteryControl.value);
							
							if (lowVoltageBatteryControl == false && filterVoltageBatteryControl.value < 131)
							{
								lowVoltageBatteryControl = true;
								soundLowVoltageBatteryControl = true;
							}
							
							if (delayDisplaySoundStartCondition.update == true)
							{
								display.word ("binding ");
							}
							
							if (soundNull == true && inhibitSound == false)
							{
								SoundWrite::play (128, 200);
								timeSoundPrevious = timeSound.ms + 200ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (soundSwitch1 == true && inhibitSound == false)
							{
								SoundWrite::play (1024, 20);
								timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (soundSwitch2 == true && inhibitSound == false)
							{
								SoundWrite::key (1024, 20);
								SoundWrite::key (0, 40);
								SoundWrite::key (1024, 20);
								SoundWrite::playKey();
								
								timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (soundSwitch3 == true && inhibitSound == false)
							{
								SoundWrite::key (1024, 20);
								SoundWrite::key (0, 40);
								SoundWrite::key (1024, 20);
								SoundWrite::key (0, 40);
								SoundWrite::key (1024, 20);
								SoundWrite::playKey();
								
								timeSoundPrevious = timeSound.ms + 140ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (delayDisplaySoundStartCondition.update == true)
							{
								SoundWrite::key (128, 100);
								SoundWrite::key (0, 100);
								SoundWrite::key (128, 100);
								SoundWrite::playKey();
								
								timeSoundPrevious = timeSound.ms + 300ll + (long long)(TIME_SPACE_SOUND);
							}
						
							if (soundLowVoltageBatteryControl == true && timeSound.ms > timeSoundPrevious)
							{
								delaySoundLowVoltageBatteryControl.state();
								
								if (delaySoundLowVoltageBatteryControl.update == true)
								{
									SoundWrite::play (48, 100);
								}
							}
							
							soundNull = false;
							soundSwitch1 = false;
							soundSwitch2 = false;
							soundSwitch3 = false;
							
							inhibitSound = false;
						}
						
						settingBatteryModelLow = settingBatteryModelLowTune;
						settingTimerEnd = settingTimerEndTune;
						settingTimerTrigger = settingTimerTriggerTune;
						
						for (n = 0; n < countSettingOption; n++)
						{
							settingOption [mapSettingOption [n]] = settingOptionTune [mapSettingOption [n]];
						}
						
						update = true;
						
						inhibitSound = true;
						
						while (updated == false && exit == false)
						{
							timeSound.state();
							
							delayDisplaySoundStartCondition.state();
							
							switchPowerState.read();
							buttonSelect.read();
							potentiometerThrottle.read();
							potentiometerPitch.read();
							potentiometerRoll.read();
							potentiometerYaw.read();
							switchCut.read();
							switchAuxiliaryA1.read();
							switchAuxiliaryA2.read();
							switchAuxiliaryB1.read();
							switchAuxiliaryB2.read();
							switchAuxiliaryC1.read();
							switchAuxiliaryC2.read();
							potentiometerAuxiliaryD.read();
							switchTrimThrottle1.read();
							switchTrimThrottle2.read();
							switchTrimPitch1.read();
							switchTrimPitch2.read();
							switchTrimRoll1.read();
							switchTrimRoll2.read();
							switchTrimYaw1.read();
							switchTrimYaw2.read();
							voltageBatteryControl.read();
							
							channelTelemetry.receive();
							
							channelThrottleRollAuxiliaryCAuxiliaryD.transmit ((signed long)(auxiliaryD) << 22 | (signed long)(auxiliaryC) << 20 | (signed long)(roll) << 10 | (signed long)(throttle));
							channelPitchYawCutAuxiliaryAAuxiliaryBFailSafeUpdate.transmit ((signed long)(update) << 31 | (signed long)(failSafe) << 25 | (signed long)(auxiliaryB) << 23 | (signed long)(auxiliaryA) << 21 | (signed long)(cut) << 20 | (signed long)(yaw) << 10 | (signed long)(pitch));
							
							channelSettingBatteryTimer.transmit ((signed long)(settingTimerTrigger) << 22 | (signed long)(settingTimerEnd) << 10 | (signed long)(settingBatteryModelLow));
							channelSettingTrim.transmit ((signed long)(settingTrimYaw) << 24 | (signed long)(settingTrimRoll) << 16 | (signed long)(settingTrimPitch) << 8 | (signed long)(settingTrimThrottle));
							channelSettingOption1.transmit ((signed long)(settingOptionDecimal [0]) << 31 | (signed long)(settingOptionCenter [0]) << 30 | (signed long)(settingOptionMax [0]) << 20 | (signed long)(settingOptionMin [0]) << 10 | (signed long)(settingOption [0]));
							channelSettingOption2.transmit ((signed long)(settingOptionDecimal [1]) << 31 | (signed long)(settingOptionCenter [1]) << 30 | (signed long)(settingOptionMax [1]) << 20 | (signed long)(settingOptionMin [1]) << 10 | (signed long)(settingOption [1]));
							channelSettingOption3.transmit ((signed long)(settingOptionDecimal [2]) << 31 | (signed long)(settingOptionCenter [2]) << 30 | (signed long)(settingOptionMax [2]) << 20 | (signed long)(settingOptionMin [2]) << 10 | (signed long)(settingOption [2]));
							channelSettingOption4.transmit ((signed long)(settingOptionDecimal [3]) << 31 | (signed long)(settingOptionCenter [3]) << 30 | (signed long)(settingOptionMax [3]) << 20 | (signed long)(settingOptionMin [3]) << 10 | (signed long)(settingOption [3]));
							channelSettingOption5.transmit ((signed long)(settingOptionDecimal [4]) << 31 | (signed long)(settingOptionCenter [4]) << 30 | (signed long)(settingOptionMax [4]) << 20 | (signed long)(settingOptionMin [4]) << 10 | (signed long)(settingOption [4]));
							channelSettingOption6.transmit ((signed long)(settingOptionDecimal [5]) << 31 | (signed long)(settingOptionCenter [5]) << 30 | (signed long)(settingOptionMax [5]) << 20 | (signed long)(settingOptionMin [5]) << 10 | (signed long)(settingOption [5]));
							channelSettingOption7.transmit ((signed long)(settingOptionDecimal [6]) << 31 | (signed long)(settingOptionCenter [6]) << 30 | (signed long)(settingOptionMax [6]) << 20 | (signed long)(settingOptionMin [6]) << 10 | (signed long)(settingOption [6]));
							channelSettingOption8.transmit ((signed long)(settingOptionDecimal [7]) << 31 | (signed long)(settingOptionCenter [7]) << 30 | (signed long)(settingOptionMax [7]) << 20 | (signed long)(settingOptionMin [7]) << 10 | (signed long)(settingOption [7]));
							channelSettingOption9.transmit ((signed long)(settingOptionDecimal [8]) << 31 | (signed long)(settingOptionCenter [8]) << 30 | (signed long)(settingOptionMax [8]) << 20 | (signed long)(settingOptionMin [8]) << 10 | (signed long)(settingOption [8]));
							channelSettingOption10.transmit ((signed long)(settingOptionDecimal [9]) << 31 | (signed long)(settingOptionCenter [9]) << 30 | (signed long)(settingOptionMax [9]) << 20 | (signed long)(settingOptionMin [9]) << 10 | (signed long)(settingOption [9]));
							channelSettingOption11.transmit ((signed long)(settingOptionDecimal [10]) << 31 | (signed long)(settingOptionCenter [10]) << 30 | (signed long)(settingOptionMax [10]) << 20 | (signed long)(settingOptionMin [10]) << 10 | (signed long)(settingOption [10]));
							channelSettingOption12.transmit ((signed long)(settingOptionDecimal [11]) << 31 | (signed long)(settingOptionCenter [11]) << 30 | (signed long)(settingOptionMax [11]) << 20 | (signed long)(settingOptionMin [11]) << 10 | (signed long)(settingOption [11]));
							channelSettingOption13.transmit ((signed long)(settingOptionDecimal [12]) << 31 | (signed long)(settingOptionCenter [12]) << 30 | (signed long)(settingOptionMax [12]) << 20 | (signed long)(settingOptionMin [12]) << 10 | (signed long)(settingOption [12]));
							channelSettingOption14.transmit ((signed long)(settingOptionDecimal [13]) << 31 | (signed long)(settingOptionCenter [13]) << 30 | (signed long)(settingOptionMax [13]) << 20 | (signed long)(settingOptionMin [13]) << 10 | (signed long)(settingOption [13]));
							channelSettingOption15.transmit ((signed long)(settingOptionDecimal [14]) << 31 | (signed long)(settingOptionCenter [14]) << 30 | (signed long)(settingOptionMax [14]) << 20 | (signed long)(settingOptionMin [14]) << 10 | (signed long)(settingOption [14]));
							channelSettingOption16.transmit ((signed long)(settingOptionDecimal [15]) << 31 | (signed long)(settingOptionCenter [15]) << 30 | (signed long)(settingOptionMax [15]) << 20 | (signed long)(settingOptionMin [15]) << 10 | (signed long)(settingOption [15]));
							
							if (switchPowerState.momentary == true)
							{
								if (locked == false)
								{
									SoundWrite::key (1024, 100);
									SoundWrite::key (512, 100);
									SoundWrite::key (0, 50);
									SoundWrite::key (512, 100);
									SoundWrite::key (256, 100);
									SoundWrite::key (0, 50);
									SoundWrite::key (256, 100);
									SoundWrite::key (128, 100);
									SoundWrite::playKey();
									
									for (n = 0; n < 4; n++)
									{
										display.clearDevice();
										display.draw (0b00000110, 1 + n);
										display.draw (0b00110000, 8 - n);
										Timer::pause (100);
										display.draw (0b00110000, 1 + n);
										display.draw (0b00000110, 8 - n);
										Timer::pause (100);
									}
									
									display.clearDevice();
									
									switchPowerHold.off();
									
									Timer::pause (1000);
									
									display.brightness (1);
									display.word ("shutdown");
									
									for (n = 2; n < 16; n++)
									{
										Timer::pause (30);
										display.brightness (n);
									}
									
									while (true)
									{
									}
								}
								else
								{
									soundNull = true;
								}
							}
							
							if (delayDisplaySoundStartCondition.update == true)
							{
								exitUpdate = true;
							}
							
							if (buttonSelect.momentary == true)
							{
								if (exitUpdate == true)
								{
									exit = true;
								}
								
								soundNull = true;
							}
							
							if (settingTrimThrottle != 255)
							{
								throttle = Math::round (Math::wurve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, float (settingTrimThrottle) + 384.5, 1023, 0, 0));
							}
							else
							{
								throttle = Math::round (Math::curve (SETUP_MIN_THROTTLE, potentiometerThrottle.value, SETUP_MAX_THROTTLE, 0, 1023, 0));
							}
							
							if (settingTrimPitch != 255)
							{
								pitch = Math::round (Math::wurve (SETUP_MIN_PITCH, potentiometerPitch.value, SETUP_MAX_PITCH, 0, float (settingTrimPitch) + 384.5, 1023, 0, 0));
							}
							else
							{
								pitch = Math::round (Math::curve (SETUP_MIN_PITCH, potentiometerPitch.value, SETUP_MAX_PITCH, 0, 1023, 0));
							}
							
							if (settingTrimRoll != 255)
							{
								roll = Math::round (Math::wurve (SETUP_MIN_ROLL, potentiometerRoll.value, SETUP_MAX_ROLL, 0, float (settingTrimRoll) + 384.5, 1023, 0, 0));
							}
							else
							{
								roll = Math::round (Math::curve (SETUP_MIN_ROLL, potentiometerRoll.value, SETUP_MAX_ROLL, 0, 1023, 0));
							}
							
							if (settingTrimYaw != 255)
							{
								yaw = Math::round (Math::wurve (SETUP_MIN_YAW, potentiometerYaw.value, SETUP_MAX_YAW, 0, float (settingTrimYaw) + 384.5, 1023, 0, 0));
							}
							else
							{
								yaw = Math::round (Math::curve (SETUP_MIN_YAW, potentiometerYaw.value, SETUP_MAX_YAW, 0, 1023, 0));
							}
							
							cut = switchCut.continuous;
							
							if (cut != cutPrevious)
							{
								cutPrevious = cut;
								
								if (cut == false)
								{
									soundSwitch1 = true;
								}
								else
								{
									soundSwitch2 = true;
								}
							}
							
							if (switchAuxiliaryA1.continuous == true)
							{
								auxiliaryA = 0;
							}
							else if (switchAuxiliaryA2.continuous == true)
							{
								auxiliaryA = 2;
							}
							else
							{
								auxiliaryA = 1;
							}
							
							if (auxiliaryA != auxiliaryAPrevious)
							{
								auxiliaryAPrevious = auxiliaryA;
								
								if (auxiliaryA == 0)
								{
									soundSwitch1 = true;
								}
								else if (auxiliaryA == 1)
								{
									soundSwitch2 = true;
								}
								else
								{
									soundSwitch3 = true;
								}
							}
							
							if (switchAuxiliaryB1.continuous == true)
							{
								auxiliaryB = 0;
							}
							else if (switchAuxiliaryB2.continuous == true)
							{
								auxiliaryB = 2;
							}
							else
							{
								auxiliaryB = 1;
							}
							
							if (auxiliaryB != auxiliaryBPrevious)
							{
								auxiliaryBPrevious = auxiliaryB;
								
								if (auxiliaryB == 0)
								{
									soundSwitch1 = true;
								}
								else if (auxiliaryB == 1)
								{
									soundSwitch2 = true;
								}
								else
								{
									soundSwitch3 = true;
								}
							}
							
							if (switchAuxiliaryC1.continuous == true)
							{
								auxiliaryC = 0;
							}
							else if (switchAuxiliaryC2.continuous == true)
							{
								auxiliaryC = 2;
							}
							else
							{
								auxiliaryC = 1;
							}
							
							if (auxiliaryC != auxiliaryCPrevious)
							{
								auxiliaryCPrevious = auxiliaryC;
								
								if (auxiliaryC == 0)
								{
									soundSwitch1 = true;
								}
								else if (auxiliaryC == 1)
								{
									soundSwitch2 = true;
								}
								else
								{
									soundSwitch3 = true;
								}
							}
							
							auxiliaryD = potentiometerAuxiliaryD.value;
							
							if (failSafe < 63)
							{
								failSafe++;
							}
							else
							{
								failSafe = 0;
							}
							
							filterVoltageBatteryModel.set (Math::curve (0, channelTelemetry.data & 0b00000000000000000000001111111111, 1023, 0, 55, 0));
							filterTelemetryAuxiliary.set (float ((channelTelemetry.data & 0b01111111111111111111110000000000) >> 10) / 10.0);
							updated = (channelTelemetry.data & 0b10000000000000000000000000000000) >> 31;
							
							if (switchTrimThrottle1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimThrottle2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimThrottle1.continuous == true)
							{
								delayTrimThrottle.state();
								
								if (delayTrimThrottle.update == true)
								{
									soundNull = true;
									delayTrimThrottle.set (50);
								}
							}
							else if (switchTrimThrottle2.continuous == true)
							{
								delayTrimThrottle.state();
								
								if (delayTrimThrottle.update == true)
								{
									soundNull = true;
									delayTrimThrottle.set (50);
								}
							}
							else
							{
								delayTrimThrottle.set (1000);
							}
							
							if (switchTrimPitch1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimPitch2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimPitch1.continuous == true)
							{
								delayTrimPitch.state();
								
								if (delayTrimPitch.update == true)
								{
									soundNull = true;
									delayTrimPitch.set (50);
								}
							}
							else if (switchTrimPitch2.continuous == true)
							{
								delayTrimPitch.state();
								
								if (delayTrimPitch.update == true)
								{
									soundNull = true;
									delayTrimPitch.set (50);
								}
							}
							else
							{
								delayTrimPitch.set (1000);
							}
							
							if (switchTrimRoll1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimRoll2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimRoll1.continuous == true)
							{
								delayTrimRoll.state();
								
								if (delayTrimRoll.update == true)
								{
									soundNull = true;
									delayTrimRoll.set (50);
								}
							}
							else if (switchTrimRoll2.continuous == true)
							{
								delayTrimRoll.state();
								
								if (delayTrimRoll.update == true)
								{
									soundNull = true;
									delayTrimRoll.set (50);
								}
							}
							else
							{
								delayTrimRoll.set (1000);
							}
							
							if (switchTrimYaw1.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimYaw2.momentary == true)
							{
								soundNull = true;
							}
							else if (switchTrimYaw1.continuous == true)
							{
								delayTrimYaw.state();
								
								if (delayTrimYaw.update == true)
								{
									soundNull = true;
									delayTrimYaw.set (50);
								}
							}
							else if (switchTrimYaw2.continuous == true)
							{
								delayTrimYaw.state();
								
								if (delayTrimYaw.update == true)
								{
									soundNull = true;
									delayTrimYaw.set (50);
								}
							}
							else
							{
								delayTrimYaw.set (1000);
							}
							
							filterVoltageBatteryControl.set (voltageBatteryControl.value);
							
							if (lowVoltageBatteryControl == false && filterVoltageBatteryControl.value < 131)
							{
								lowVoltageBatteryControl = true;
								soundLowVoltageBatteryControl = true;
							}
							
							if (delayDisplaySoundStartCondition.update == true)
							{
								display.word ("binding ");
							}
							
							if (soundNull == true && inhibitSound == false)
							{
								SoundWrite::play (128, 200);
								timeSoundPrevious = timeSound.ms + 200ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (soundSwitch1 == true && inhibitSound == false)
							{
								SoundWrite::play (1024, 20);
								timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (soundSwitch2 == true && inhibitSound == false)
							{
								SoundWrite::key (1024, 20);
								SoundWrite::key (0, 40);
								SoundWrite::key (1024, 20);
								SoundWrite::playKey();
								
								timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (soundSwitch3 == true && inhibitSound == false)
							{
								SoundWrite::key (1024, 20);
								SoundWrite::key (0, 40);
								SoundWrite::key (1024, 20);
								SoundWrite::key (0, 40);
								SoundWrite::key (1024, 20);
								SoundWrite::playKey();
								
								timeSoundPrevious = timeSound.ms + 140ll + (long long)(TIME_SPACE_SOUND);
							}
							else if (delayDisplaySoundStartCondition.update == true)
							{
								SoundWrite::key (128, 100);
								SoundWrite::key (0, 100);
								SoundWrite::key (128, 100);
								SoundWrite::playKey();
								
								timeSoundPrevious = timeSound.ms + 300ll + (long long)(TIME_SPACE_SOUND);
							}
						
							if (soundLowVoltageBatteryControl == true && timeSound.ms > timeSoundPrevious)
							{
								delaySoundLowVoltageBatteryControl.state();
								
								if (delaySoundLowVoltageBatteryControl.update == true)
								{
									SoundWrite::play (48, 100);
								}
							}
							
							soundNull = false;
							soundSwitch1 = false;
							soundSwitch2 = false;
							soundSwitch3 = false;
							
							inhibitSound = false;
						}
						
						update = false;
						menuSetting = false;
						
						stateLocked = 2;
						
						delayTrimThrottle.set (1000);
						delayTrimPitch.set (1000);
						delayTrimRoll.set (1000);
						delayTrimYaw.set (1000);
						
						if (lowVoltageBatteryControl == true)
						{
							delayDisplayLowVoltageBatteryControl.reset();
							displayVoltageBatteryControl = 1;
						}
						
						if (lowVoltageBatteryModel == true)
						{
							delayDisplayLowVoltageBatteryModel.reset();
							displayVoltageBatteryModel = 1;
						}
						
						if (timerEnded == true)
						{
							delayDisplayTimerEnded.reset();
							displayTimerEnded = 1;
						}
						
						select.set (Math::curve (0, potentiometerSelect.value, 1023, 0, 9, 0));
						selectPrevious = select.value;
						
						if (exitUpdate == true && exit == false)
						{
							SoundWrite::key (1024, 20);
							SoundWrite::key (0, 40);
							SoundWrite::key (1024, 20);
							SoundWrite::playKey();
							
							timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
						}
					}
					else
					{
						soundNull = true;
					}
				}
			}
		}
		
		if (brightness <= 16 && timeDisplay.ms >= timeDisplayPrevious)
		{
			display.brightness (brightness);
			
			brightness++;
			timeDisplayPrevious = timeDisplay.ms + 30ll;
		}
		
		if (soundSelect == true && inhibitSound == false)
		{
			SoundWrite::play (1024, 20);
			timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundOk == true)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 60ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundNull == true && inhibitSound == false)
		{
			SoundWrite::play (128, 200);
			timeSoundPrevious = timeSound.ms + 200ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundLock == true)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 60ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundLocked == true)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 20);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 220ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundTimerStart == true)
		{
			SoundWrite::key (256, 60);
			SoundWrite::key (0, 40);
			SoundWrite::key (512, 60);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 60);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 260ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSwitch1 == true && inhibitSound == false)
		{
			SoundWrite::play (1024, 20);
			timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSwitch2 == true && inhibitSound == false)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 80ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundSwitch3 == true && inhibitSound == false)
		{
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::key (0, 40);
			SoundWrite::key (1024, 20);
			SoundWrite::playKey();
			
			timeSoundPrevious = timeSound.ms + 140ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundTune == true && inhibitSound == false && timeSound.ms > timeSoundPrevious)
		{
			SoundWrite::play (2048, 1);
			timeSoundPrevious = timeSound.ms + 30ll + (long long)(TIME_SPACE_SOUND);
		}
		else if (soundLowVoltageBatteryModel >= 1 && soundLowVoltageBatteryModel <= 6)
		{
			delaySoundLowVoltageBatteryModel.state();
			
			if (delaySoundLowVoltageBatteryModel.update == true)
			{
				if (soundLowVoltageBatteryModel != 6)
				{
					SoundWrite::key (48, 100);
					SoundWrite::key (0, 50);
					SoundWrite::key (48, 100);
					SoundWrite::playKey();
					
					timeSoundPrevious = timeSound.ms + 250ll + (long long)(TIME_SPACE_SOUND);
				}
				else
				{
					SoundWrite::play (48, 2000);
					timeSoundPrevious = timeSound.ms + 2000ll + (long long)(TIME_SPACE_SOUND);
				}
				
				soundLowVoltageBatteryModel++;
			}
		}
		else if (soundTimerEnded >= 1 && soundTimerEnded <= 6)
		{
			delaySoundTimerEnded.state();
			
			if (delaySoundTimerEnded.update == true)
			{
				if (soundTimerEnded == 1)
				{
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::playKey();
					
					timeSoundPrevious = timeSound.ms + 300ll + (long long)(TIME_SPACE_SOUND);
				}
				else if (soundTimerEnded == 2)
				{
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::playKey();
					
					timeSoundPrevious = timeSound.ms + 230ll + (long long)(TIME_SPACE_SOUND);
				}
				else if (soundTimerEnded == 3)
				{
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::playKey();
					
					timeSoundPrevious = timeSound.ms + 160ll + (long long)(TIME_SPACE_SOUND);
				}
				else if (soundTimerEnded == 4)
				{
					SoundWrite::key (128, 20);
					SoundWrite::key (0, 50);
					SoundWrite::key (128, 20);
					SoundWrite::playKey();
					
					timeSoundPrevious = timeSound.ms + 90ll + (long long)(TIME_SPACE_SOUND);
				}
				else if (soundTimerEnded == 5)
				{
					SoundWrite::play (128, 20);
					timeSoundPrevious = timeSound.ms + 20ll + (long long)(TIME_SPACE_SOUND);
				}
				else
				{
					SoundWrite::play (128, 2000);
					timeSoundPrevious = timeSound.ms + 2000ll + (long long)(TIME_SPACE_SOUND);
				}
				
				soundTimerEnded++;
			}
		}
		
		if (soundLowVoltageBatteryControl == true && timeSound.ms > timeSoundPrevious)
		{
			delaySoundLowVoltageBatteryControl.state();
			
			if (delaySoundLowVoltageBatteryControl.update == true)
			{
				SoundWrite::play (48, 100);
			}
		}
		
		soundSelect = false;
		soundOk = false;
		soundNull = false;
		soundLock = false;
		soundLocked = false;
		soundTimerStart = false;
		soundSwitch1 = false;
		soundSwitch2 = false;
		soundSwitch3 = false;
		soundTune = false;
		
		inhibitSound = false;
	}
	
	return 0;
}
